Index: LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/phytracr_spl_mod.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/phytracr_spl_mod.F90	(revision 5098)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/phytracr_spl_mod.F90	(revision 5099)
@@ -3564,1065 +3446,1044 @@
 #endif
 
-
-!
-      IF (logitime) THEN
-      CALL SYSTEM_CLOCK(COUNT=clock_start)
+    IF (logitime) THEN
+      CALL SYSTEM_CLOCK(COUNT = clock_start)
+    ENDIF
+
+    DO itr = 1, nbtr
+      DO j = 1, klev
+        DO i = 1, klon
+          tmp_var(i, j) = tr_seri(i, j, itr)
+        ENDDO
+      ENDDO
+      CALL cm3_to_kg(pplay, t_seri, tmp_var)
+      DO j = 1, klev
+        DO i = 1, klon
+          tr_seri(i, j, itr) = tmp_var(i, j)
+        ENDDO
+      ENDDO
+    ENDDO
+    iscm3 = .false.
+
+
+    !======================================================================
+    !  SAVING AEROSOL RELATED VARIABLES INTO FILE
+    !======================================================================
+
+    ndex2d = 0
+    ndex3d = 0
+
+    itra = itra + 1
+
+    print *, 'SAVING VARIABLES FOR DAY ', itra
+
+    fluxbb(:) = 0.0
+    fluxff(:) = 0.0
+    fluxbcbb(:) = 0.0
+    fluxbcff(:) = 0.0
+    fluxbcnff(:) = 0.0
+    fluxbcba(:) = 0.0
+    fluxbc(:) = 0.0
+    fluxombb(:) = 0.0
+    fluxomff(:) = 0.0
+    fluxomnat(:) = 0.0
+    fluxomba(:) = 0.0
+    fluxomnff(:) = 0.0
+    fluxom(:) = 0.0
+    fluxh2sff(:) = 0.0
+    fluxh2snff(:) = 0.0
+    fluxh2sbio(:) = 0.0
+    fluxso2ff(:) = 0.0
+    fluxso2nff(:) = 0.0
+    fluxso2bb(:) = 0.0
+    fluxso2vol(:) = 0.0
+    fluxso2ba(:) = 0.0
+    fluxso2(:) = 0.0
+    fluxso4ff(:) = 0.0
+    fluxso4nff(:) = 0.0
+    fluxso4bb(:) = 0.0
+    fluxso4ba(:) = 0.0
+    fluxso4(:) = 0.0
+    fluxdms(:) = 0.0
+    fluxdustec(:) = 0.0
+    fluxddfine(:) = 0.0
+    fluxddcoa(:) = 0.0
+    fluxddsco(:) = 0.0
+    fluxdd(:) = 0.0
+    fluxssfine(:) = 0.0
+    fluxsscoa(:) = 0.0
+    fluxss(:) = 0.0
+    DO i = 1, klon
+      IF (iregion_ind(i)>0) THEN           ! LAND
+        ! SULFUR EMISSIONS
+        fluxh2sff(i) = (lmt_so2ff_l(i) + lmt_so2ff_h(i)) * frach2sofso2 * &
+                scale_param_ind(iregion_ind(i)) * &
+                1.e4 / RNAVO * masse_s * 1.e3         ! mgS/m2/s
+        fluxso2ff(i) = scale_param_ind(iregion_ind(i)) * fracso2emis * &
+                (lmt_so2ff_l(i) + lmt_so2ff_h(i)) * 1.e4 / RNAVO * &
+                masse_s * 1.e3  ! mgS/m2/s
+        ! SULPHATE EMISSIONS
+        fluxso4ff(i) = scale_param_ind(iregion_ind(i)) * (1 - fracso2emis) * &
+                (lmt_so2ff_l(i) + lmt_so2ff_h(i)) * 1.e4 / RNAVO * &
+                masse_s * 1.e3  ! mgS/m2/s
+        ! BLACK CARBON EMISSIONS
+        fluxbcff(i) = scale_param_ff(iregion_ind(i)) * &
+                lmt_bcff(i) * 1.e4 * 1.e3  !/g/m2/s
+        ! ORGANIC MATTER EMISSIONS
+        fluxomff(i) = scale_param_ff(iregion_ind(i)) * &
+                (lmt_omff(i)) * 1.e4 * 1.e3  !/g/m2/s
+        ! FOSSIL FUEL EMISSIONS
+        fluxff(i) = fluxbcff(i) + fluxomff(i)
       ENDIF
-
-      DO itr=1,nbtr
-         DO j=1,klev
-         DO i=1,klon
-           tmp_var(i,j)=tr_seri(i,j,itr)
-         ENDDO 
-         ENDDO
-         CALL cm3_to_kg(pplay,t_seri,tmp_var)
-         DO j=1,klev
-         DO i=1,klon
-           tr_seri(i,j,itr)=tmp_var(i,j)
-         ENDDO 
-         ENDDO
-      ENDDO
-       iscm3=.false.
-
-!
-!
-!======================================================================
-!  SAVING AEROSOL RELATED VARIABLES INTO FILE
-!======================================================================
-!
-      ndex2d = 0
-      ndex3d = 0 
-!
-      itra=itra+1
-
-      print *,'SAVING VARIABLES FOR DAY ',itra
-!
-      fluxbb(:)=0.0
-      fluxff(:)=0.0
-      fluxbcbb(:)=0.0
-      fluxbcff(:)=0.0
-      fluxbcnff(:)=0.0
-      fluxbcba(:)=0.0
-      fluxbc(:)=0.0
-      fluxombb(:)=0.0
-      fluxomff(:)=0.0
-      fluxomnat(:)=0.0
-      fluxomba(:)=0.0
-      fluxomnff(:)=0.0
-      fluxom(:)=0.0
-      fluxh2sff(:)=0.0
-      fluxh2snff(:)=0.0
-      fluxh2sbio(:)=0.0
-      fluxso2ff(:)=0.0
-      fluxso2nff(:)=0.0
-      fluxso2bb(:)=0.0
-      fluxso2vol(:)=0.0
-      fluxso2ba(:)=0.0
-      fluxso2(:)=0.0
-      fluxso4ff(:)=0.0
-      fluxso4nff(:)=0.0
-      fluxso4bb(:)=0.0
-      fluxso4ba(:)=0.0
-      fluxso4(:)=0.0
-      fluxdms(:)=0.0
-      fluxdustec(:)=0.0
-      fluxddfine(:)=0.0
-      fluxddcoa(:)=0.0
-      fluxddsco(:)=0.0
-      fluxdd(:)=0.0
-      fluxssfine(:)=0.0
-      fluxsscoa(:)=0.0
-      fluxss(:)=0.0
-      DO i=1, klon
-         IF (iregion_ind(i)>0) THEN           ! LAND
-           ! SULFUR EMISSIONS
-           fluxh2sff(i)= (lmt_so2ff_l(i)+lmt_so2ff_h(i))*frach2sofso2*  &       
-                         scale_param_ind(iregion_ind(i))*               &
-                                    1.e4/RNAVO*masse_s*1.e3         ! mgS/m2/s
-           fluxso2ff(i)=scale_param_ind(iregion_ind(i)) * fracso2emis * &
-                        (lmt_so2ff_l(i)+lmt_so2ff_h(i)) * 1.e4/RNAVO * &
-                                                    masse_s * 1.e3  ! mgS/m2/s
-           ! SULPHATE EMISSIONS
-           fluxso4ff(i)=scale_param_ind(iregion_ind(i))*(1-fracso2emis)* &
-                         (lmt_so2ff_l(i)+lmt_so2ff_h(i)) * 1.e4/RNAVO * &
-                                                    masse_s * 1.e3  ! mgS/m2/s
-           ! BLACK CARBON EMISSIONS
-           fluxbcff(i)=scale_param_ff(iregion_ind(i))* &
-                                             lmt_bcff(i)*1.e4*1.e3  !/g/m2/s
-           ! ORGANIC MATTER EMISSIONS
-           fluxomff(i)=scale_param_ff(iregion_ind(i))* &
-                               (lmt_omff(i))*1.e4*1.e3  !/g/m2/s
-           ! FOSSIL FUEL EMISSIONS
-           fluxff(i)=fluxbcff(i)+fluxomff(i)
-         ENDIF
-         IF (iregion_bb(i)>0) THEN           ! LAND
-           ! SULFUR EMISSIONS
-           fluxso2bb(i) =scale_param_bb(iregion_bb(i)) * fracso2emis *  &
-                      (lmt_so2bb_l(i)+lmt_so2bb_h(i))*                 &
-                (1.-pctsrf(i,is_oce))*1.e4/RNAVO*masse_s*1.e3       ! mgS/m2/s
-           ! SULPHATE EMISSIONS
-           fluxso4bb(i) =scale_param_bb(iregion_bb(i))*(1-fracso2emis)* &
-                      (lmt_so2bb_l(i)+lmt_so2bb_h(i))*                 &
-                (1.-pctsrf(i,is_oce))*1.e4/RNAVO*masse_s*1.e3       ! mgS/m2/s
-           ! BLACK CARBON EMISSIONS
-           fluxbcbb(i)=scale_param_bb(iregion_bb(i))*                   &
-                           (lmt_bcbb_l(i)+lmt_bcbb_h(i))*1.e4*1.e3  !mg/m2/s
-           ! ORGANIC MATTER EMISSIONS
-           fluxombb(i)=scale_param_bb(iregion_bb(i))*                   &
-                           (lmt_ombb_l(i)+lmt_ombb_h(i))*1.e4*1.e3  !mg/m2/s
-           ! BIOMASS BURNING EMISSIONS
-           fluxbb(i)=fluxbcbb(i)+fluxombb(i)
-         ENDIF
-         ! H2S EMISSIONS
-         fluxh2sbio(i)=lmt_h2sbio(i)*1.e4/RNAVO*masse_s*1.e3      ! mgS/m2/s
-         fluxh2snff(i)= lmt_so2nff(i)*frach2sofso2*  &
-                                    1.e4/RNAVO*masse_s*1.e3         ! mgS/m2/s
-         ! SULFUR DIOXIDE EMISSIONS
-         fluxso2nff(i)=fracso2emis * lmt_so2nff(i) * 1.e4/RNAVO *  &
-                                                    masse_s * 1.e3  ! mgS/m2/s
-         fluxso2vol(i)=(lmt_so2volc_cont(i)+lmt_so2volc_expl(i))  &
-                      *1.e4/RNAVO*masse_s*1.e3        ! mgS/m2/s
-         fluxso2ba(i) =lmt_so2ba(i)*1.e4/RNAVO*masse_s*1.e3*      &
-                                                        fracso2emis ! mgS/m2/s
-         fluxso2(i)=fluxso2ff(i)+fluxso2bb(i)+fluxso2nff(i)+   &
-                   fluxso2vol(i)+fluxso2ba(i)
-         ! DMS EMISSIONS
-         fluxdms(i)=( lmt_dms(i)+lmt_dmsbio(i) )              &
-                   *1.e4/RNAVO*masse_s*1.e3          ! mgS/m2/s
-         ! SULPHATE EMISSIONS
-         fluxso4ba(i) =lmt_so2ba(i)*1.e4/RNAVO*masse_s*1.e3        &
-                      *(1-fracso2emis) ! mgS/m2/s
-         fluxso4nff(i)=(1-fracso2emis)*lmt_so2nff(i) * 1.e4/RNAVO *  &
-                                                    masse_s * 1.e3  ! mgS/m2/s
-         fluxso4(i)=fluxso4ff(i)+fluxso4bb(i)+fluxso4ba(i)+fluxso4nff(i)
-         ! BLACK CARBON EMISSIONS
-
-         fluxbcnff(i)=lmt_bcnff(i)*1.e4*1.e3  !mg/m2/s
-         fluxbcba(i)=lmt_bcba(i)*1.e4*1.e3    !mg/m2/s
-         fluxbc(i)=fluxbcbb(i)+fluxbcff(i)+fluxbcnff(i)+fluxbcba(i)
-         ! ORGANIC MATTER EMISSIONS
-         fluxomnat(i)=lmt_omnat(i)*1.e4*1.e3  !mg/m2/s
-         fluxomba(i)=lmt_omba(i)*1.e4*1.e3  !mg/m2/s
-         fluxomnff(i)=lmt_omnff(i)*1.e4*1.e3  !mg/m2/s
-         fluxom(i)=fluxombb(i)+fluxomff(i)+fluxomnat(i)+fluxomba(i)+  &
-                  fluxomnff(i)
-        ! DUST EMISSIONS 
-         fluxdustec(i)=dust_ec(i)*1.e6 ! old dust emission scheme 
-!JE20140605<<         old dust emission version
-!         fluxddfine(i)=scale_param_dustacc(iregion_dust(i))
-!     .                                  * dust_ec(i)*0.093*1.e6
-!         fluxddcoa(i)=scale_param_dustcoa(iregion_dust(i))
-!     .                                  * dust_ec(i)*0.905*1.e6
-!         fluxdd(i)=fluxddfine(i)+fluxddcoa(i)
-!JE20140605>>
-         fluxddfine(i)=flux_sparam_ddfine(i)
-         fluxddcoa(i)=flux_sparam_ddcoa(i)
-         fluxddsco(i)=flux_sparam_ddsco(i)
-         fluxdd(i)=fluxddfine(i)+fluxddcoa(i)+fluxddsco(i)
-        ! SEA SALT EMISSIONS 
-         fluxssfine(i)=scale_param_ssacc*lmt_sea_salt(i,1)*1.e4*1.e3
-         fluxsscoa(i)=scale_param_sscoa*lmt_sea_salt(i,2)*1.e4*1.e3
-         fluxss(i)=fluxssfine(i)+fluxsscoa(i)
-      ENDDO
-
-!      prepare outputs cvltr
-
-      DO itr=1,nbtr
-        DO k=1,klev
-        DO i=1,klon
-           tmp_var(i,k)=d_tr_cv(i,k,itr)
-        ENDDO
-        ENDDO
-        CALL kg_to_cm3(pplay,t_seri,tmp_var)
-       DO k=1,klev
-        DO i=1,klon
-          d_tr_cv_o(i,k,itr)=tmp_var(i,k)  &
-                         /RNAVO*masse(itr)*1.e3*1.e6*zdz(i,k)/pdtphys  
-        ENDDO
-       ENDDO
-      ENDDO
-      DO itr=1,nbtr
-        DO k=1,klev
-        DO i=1,klon
-           tmp_var(i,k)=d_tr_trsp(i,k,itr)
-        ENDDO
-        ENDDO
-        CALL kg_to_cm3(pplay,t_seri,tmp_var)
-       DO k=1,klev
-        DO i=1,klon
-          d_tr_trsp_o(i,k,itr)=tmp_var(i,k)  &
-                         /RNAVO*masse(itr)*1.e3*1.e6*zdz(i,k)/pdtphys  
-        ENDDO
-       ENDDO
-      ENDDO
-      DO itr=1,nbtr
-        DO k=1,klev
-        DO i=1,klon
-           tmp_var(i,k)=d_tr_sscav(i,k,itr)
-        ENDDO
-        ENDDO
-        CALL kg_to_cm3(pplay,t_seri,tmp_var)
-       DO k=1,klev
-        DO i=1,klon
-          d_tr_sscav_o(i,k,itr)=tmp_var(i,k)  &
-                         /RNAVO*masse(itr)*1.e3*1.e6*zdz(i,k)/pdtphys  
-        ENDDO
-       ENDDO
-      ENDDO
-      DO itr=1,nbtr
-        DO k=1,klev
-        DO i=1,klon
-           tmp_var(i,k)=d_tr_sat(i,k,itr)
-        ENDDO
-        ENDDO
-        CALL kg_to_cm3(pplay,t_seri,tmp_var)
-       DO k=1,klev
-        DO i=1,klon
-          d_tr_sat_o(i,k,itr)=tmp_var(i,k)   &
-                         /RNAVO*masse(itr)*1.e3*1.e6*zdz(i,k)/pdtphys  
-        ENDDO
-       ENDDO
-      ENDDO
-      DO itr=1,nbtr
-        DO k=1,klev
-        DO i=1,klon
-           tmp_var(i,k)=d_tr_uscav(i,k,itr)
-        ENDDO
-        ENDDO
-        CALL kg_to_cm3(pplay,t_seri,tmp_var)
-       DO k=1,klev
-        DO i=1,klon
-          d_tr_uscav_o(i,k,itr)=tmp_var(i,k)  &
-                         /RNAVO*masse(itr)*1.e3*1.e6*zdz(i,k)/pdtphys  
-        ENDDO
-       ENDDO
-      ENDDO
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-      DO itr=1,nbtr
-        DO k=1,klev
-        DO i=1,klon
-           tmp_var(i,k)=d_tr_insc(i,k,itr)
-        ENDDO
-        ENDDO
-        CALL kg_to_cm3(pplay,t_seri,tmp_var)
-       DO k=1,klev
-        DO i=1,klon
-          d_tr_insc_o(i,k,itr)=tmp_var(i,k)  &
-                         /RNAVO*masse(itr)*1.e3*1.e6*zdz(i,k)/pdtphys  
-        ENDDO
-       ENDDO
-      ENDDO
-     
-
-      DO itr=1,nbtr
-        DO k=1,klev
-        DO i=1,klon
-           tmp_var(i,k)=d_tr_bcscav(i,k,itr)
-        ENDDO
-        ENDDO
-        CALL kg_to_cm3(pplay,t_seri,tmp_var)
-       DO k=1,klev
-        DO i=1,klon
-          d_tr_bcscav_o(i,k,itr)=tmp_var(i,k)  &
-                         /RNAVO*masse(itr)*1.e3*1.e6*zdz(i,k)/pdtphys  
-        ENDDO
-       ENDDO
-      ENDDO
-
-
-      DO itr=1,nbtr
-        DO k=1,klev
-        DO i=1,klon
-           tmp_var(i,k)=d_tr_evapls(i,k,itr)
-        ENDDO
-        ENDDO
-        CALL kg_to_cm3(pplay,t_seri,tmp_var)
-       DO k=1,klev
-        DO i=1,klon
-          d_tr_evapls_o(i,k,itr)=tmp_var(i,k)  &
-                         /RNAVO*masse(itr)*1.e3*1.e6*zdz(i,k)/pdtphys  
-        ENDDO
-       ENDDO
-      ENDDO
-
-
-      DO itr=1,nbtr
-        DO k=1,klev
-        DO i=1,klon
-           tmp_var(i,k)=d_tr_ls(i,k,itr)
-        ENDDO
-        ENDDO
-        CALL kg_to_cm3(pplay,t_seri,tmp_var)
-       DO k=1,klev
-        DO i=1,klon
-          d_tr_ls_o(i,k,itr)=tmp_var(i,k)  &
-                         /RNAVO*masse(itr)*1.e3*1.e6*zdz(i,k)/pdtphys  
-        ENDDO
-       ENDDO
-      ENDDO
-
-
-      DO itr=1,nbtr
-        DO k=1,klev
-        DO i=1,klon
-           tmp_var(i,k)=d_tr_dyn(i,k,itr)
-        ENDDO
-        ENDDO
-        CALL kg_to_cm3(pplay,t_seri,tmp_var)
-       DO k=1,klev
-        DO i=1,klon
-          d_tr_dyn_o(i,k,itr)=tmp_var(i,k)  &
-                         /RNAVO*masse(itr)*1.e3*1.e6*zdz(i,k)/pdtphys  
-        ENDDO
-       ENDDO
-      ENDDO
-
-
-      DO itr=1,nbtr
-        DO k=1,klev
-        DO i=1,klon
-           tmp_var(i,k)=d_tr_cl(i,k,itr)
-        ENDDO
-        ENDDO
-        CALL kg_to_cm3(pplay,t_seri,tmp_var)
-       DO k=1,klev
-        DO i=1,klon
-          d_tr_cl_o(i,k,itr)=tmp_var(i,k)  &
-                         /RNAVO*masse(itr)*1.e3*1.e6*zdz(i,k)/pdtphys  
-        ENDDO
-       ENDDO
-      ENDDO
-
-
-      DO itr=1,nbtr
-        DO k=1,klev
-        DO i=1,klon
-           tmp_var(i,k)=d_tr_th(i,k,itr)
-        ENDDO
-        ENDDO
-        CALL kg_to_cm3(pplay,t_seri,tmp_var)
-       DO k=1,klev
-        DO i=1,klon
-          d_tr_th_o(i,k,itr)=tmp_var(i,k)  &
-                         /RNAVO*masse(itr)*1.e3*1.e6*zdz(i,k)/pdtphys  
-        ENDDO
-       ENDDO
-      ENDDO
-     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-
-     DO itr=1,nbtr
-      WRITE(str2,'(i2.2)') itr
-       DO i=1, klon                                                        
-        his_dh(i,itr)= his_dhlsc(i,itr)+his_dhcon(i,itr)+               &
-                   his_dhbclsc(i,itr)+his_dhbccon(i,itr)
-
-       ENDDO
-      ENDDO
-
-!AS: commenting out and deleting lines 
-!!      IF (ok_histrac) THEN
-!!
-!! SAVING VARIABLES IN TRACEUR
-!!----- many lines deleted----
-!!      ENDIF ! ok_histrac                                                    
-                                                                            
-
-
-
-!JE20141224
-! saving variables for output
-! 2D outputs
-      DO i=1, klon
-       trm01(i)=0. 
-       trm02(i)=0. 
-       trm03(i)=0. 
-       trm04(i)=0. 
-       trm05(i)=0.
-       sconc01(i)=0. 
-       sconc02(i)=0. 
-       sconc03(i)=0. 
-       sconc04(i)=0. 
-       sconc05(i)=0.
-       flux01(i)=0. 
-       flux02(i)=0. 
-       flux03(i)=0. 
-       flux04(i)=0. 
-       flux05(i)=0.
-       ds01(i)=0. 
-       ds02(i)=0. 
-       ds03(i)=0. 
-       ds04(i)=0. 
-       ds05(i)=0.
-       dh01(i)=0. 
-       dh02(i)=0. 
-       dh03(i)=0. 
-       dh04(i)=0. 
-       dh05(i)=0.
-       dtrconv01(i)=0. 
-       dtrconv02(i)=0. 
-       dtrconv03(i)=0. 
-       dtrconv04(i)=0. 
-       dtrconv05(i)=0.
-       dtherm01(i)=0. 
-       dtherm02(i)=0. 
-       dtherm03(i)=0. 
-       dtherm04(i)=0. 
-       dtherm05(i)=0.
-       dhkecv01(i)=0. 
-       dhkecv02(i)=0. 
-       dhkecv03(i)=0. 
-       dhkecv04(i)=0. 
-       dhkecv05(i)=0.
-       d_tr_ds01(i)=0. 
-       d_tr_ds02(i)=0. 
-       d_tr_ds03(i)=0. 
-       d_tr_ds04(i)=0. 
-       d_tr_ds05(i)=0.
-       dhkelsc01(i)=0. 
-       dhkelsc02(i)=0. 
-       dhkelsc03(i)=0. 
-       dhkelsc04(i)=0. 
-       dhkelsc05(i)=0.
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-
-      if(id_prec>0)  trm01(i)=trm(i,id_prec) 
-      if(id_fine>0)  trm02(i)=trm(i,id_fine) 
-      if(id_coss>0)  trm03(i)=trm(i,id_coss) 
-      if(id_codu>0)  trm04(i)=trm(i,id_codu) 
-      if(id_scdu>0)  trm05(i)=trm(i,id_scdu)
-      if(id_prec>0)    sconc01(i)=sconc_seri(i,id_prec)
-      if(id_fine>0)    sconc02(i)=sconc_seri(i,id_fine)
-      if(id_coss>0)    sconc03(i)=sconc_seri(i,id_coss)
-      if(id_codu>0)    sconc04(i)=sconc_seri(i,id_codu)
-      if(id_scdu>0)    sconc05(i)=sconc_seri(i,id_scdu)
-      if(id_prec>0)    flux01(i)=flux_tr(i,id_prec)
-      if(id_fine>0)    flux02(i)=flux_tr(i,id_fine)
-      if(id_coss>0)    flux03(i)=flux_tr(i,id_coss)
-      if(id_codu>0)    flux04(i)=flux_tr(i,id_codu)
-      if(id_scdu>0)    flux05(i)=flux_tr(i,id_scdu)
-      if(id_prec>0)    ds01(i)=his_ds(i,id_prec)
-      if(id_fine>0)    ds02(i)=his_ds(i,id_fine)
-      if(id_coss>0)    ds03(i)=his_ds(i,id_coss)
-      if(id_codu>0)    ds04(i)=his_ds(i,id_codu)
-      if(id_scdu>0)    ds05(i)=his_ds(i,id_scdu)
-      if(id_prec>0)    dh01(i)=his_dh(i,id_prec)
-      if(id_fine>0)    dh02(i)=his_dh(i,id_fine)
-      if(id_coss>0)    dh03(i)=his_dh(i,id_coss)
-      if(id_codu>0)    dh04(i)=his_dh(i,id_codu)
-      if(id_scdu>0)    dh05(i)=his_dh(i,id_scdu)
-      if(id_prec>0)    dtrconv01(i)=dtrconv(i,id_prec)
-      if(id_fine>0)    dtrconv02(i)=dtrconv(i,id_fine)
-      if(id_coss>0)    dtrconv03(i)=dtrconv(i,id_coss)
-      if(id_codu>0)    dtrconv04(i)=dtrconv(i,id_codu)
-      if(id_scdu>0)    dtrconv05(i)=dtrconv(i,id_scdu)
-      if(id_prec>0)    dtherm01(i)=his_th(i,id_prec)
-      if(id_fine>0)    dtherm02(i)=his_th(i,id_fine)
-      if(id_coss>0)    dtherm03(i)=his_th(i,id_coss)
-      if(id_codu>0)    dtherm04(i)=his_th(i,id_codu)
-      if(id_scdu>0)    dtherm05(i)=his_th(i,id_scdu)
-      if(id_prec>0)    dhkecv01(i)=his_dhkecv(i,id_prec)
-      if(id_fine>0)    dhkecv02(i)=his_dhkecv(i,id_fine)
-      if(id_coss>0)    dhkecv03(i)=his_dhkecv(i,id_coss)
-      if(id_codu>0)    dhkecv04(i)=his_dhkecv(i,id_codu)
-      if(id_scdu>0)    dhkecv05(i)=his_dhkecv(i,id_scdu)
-      if(id_prec>0)    d_tr_ds01(i)=his_ds(i,id_prec)
-      if(id_fine>0)    d_tr_ds02(i)=his_ds(i,id_fine)
-      if(id_coss>0)    d_tr_ds03(i)=his_ds(i,id_coss)
-      if(id_codu>0)    d_tr_ds04(i)=his_ds(i,id_codu)
-      if(id_scdu>0)    d_tr_ds05(i)=his_ds(i,id_scdu)
-      if(id_prec>0)    dhkelsc01(i)=his_dhkelsc(i,id_prec)
-      if(id_fine>0)    dhkelsc02(i)=his_dhkelsc(i,id_fine)
-      if(id_coss>0)    dhkelsc03(i)=his_dhkelsc(i,id_coss)
-      if(id_codu>0)    dhkelsc04(i)=his_dhkelsc(i,id_codu)
-      if(id_scdu>0)    dhkelsc05(i)=his_dhkelsc(i,id_scdu)
-       u10m_ss(i)=u10m_ec(i)
-       v10m_ss(i)=v10m_ec(i)
-      ENDDO
-! 3D outs
-      DO i=1, klon
-        DO k=1,klev
-      d_tr_cv01(i,k)   =0.
-      d_tr_cv02(i,k)   =0.
-      d_tr_cv03(i,k)   =0.
-      d_tr_cv04(i,k)   =0.
-      d_tr_cv05(i,k)   =0.
-      d_tr_trsp01(i,k) =0.
-      d_tr_trsp02(i,k) =0.
-      d_tr_trsp03(i,k) =0.
-      d_tr_trsp04(i,k) =0.
-      d_tr_trsp05(i,k) =0.
-      d_tr_sscav01(i,k)=0.
-      d_tr_sscav02(i,k)=0.
-      d_tr_sscav03(i,k)=0.
-      d_tr_sscav04(i,k)=0.
-      d_tr_sscav05(i,k)=0.
-      d_tr_sat01(i,k)  =0.
-      d_tr_sat02(i,k)  =0.
-      d_tr_sat03(i,k)  =0.
-      d_tr_sat04(i,k)  =0.
-      d_tr_sat05(i,k)  =0.
-      d_tr_uscav01(i,k)=0.
-      d_tr_uscav02(i,k)=0.
-      d_tr_uscav03(i,k)=0.
-      d_tr_uscav04(i,k)=0.
-      d_tr_uscav05(i,k)=0.
-      d_tr_insc01(i,k)=0.!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-      d_tr_insc02(i,k)=0.
-      d_tr_insc03(i,k)=0.
-      d_tr_insc04(i,k)=0.
-      d_tr_insc05(i,k)=0.
-      d_tr_bcscav01(i,k)=0.
-      d_tr_bcscav02(i,k)=0.
-      d_tr_bcscav03(i,k)=0.
-      d_tr_bcscav04(i,k)=0.
-      d_tr_bcscav05(i,k)=0.
-      d_tr_evapls01(i,k)=0.
-      d_tr_evapls02(i,k)=0.
-      d_tr_evapls03(i,k)=0.
-      d_tr_evapls04(i,k)=0.
-      d_tr_evapls05(i,k)=0.
-      d_tr_ls01(i,k)=0.
-      d_tr_ls02(i,k)=0.
-      d_tr_ls03(i,k)=0.
-      d_tr_ls04(i,k)=0.
-      d_tr_ls05(i,k)=0.!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-      d_tr_dyn01(i,k)=0.
-      d_tr_dyn02(i,k)=0.
-      d_tr_dyn03(i,k)=0.
-      d_tr_dyn04(i,k)=0.
-      d_tr_dyn05(i,k)=0.!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-      d_tr_cl01(i,k)=0.
-      d_tr_cl02(i,k)=0.
-      d_tr_cl03(i,k)=0.
-      d_tr_cl04(i,k)=0.
-      d_tr_cl05(i,k)=0.!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-      d_tr_th01(i,k)=0.
-      d_tr_th02(i,k)=0.
-      d_tr_th03(i,k)=0.
-      d_tr_th04(i,k)=0.
-      d_tr_th05(i,k)=0.!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-        ENDDO
-      ENDDO
-
-      IF(1==0) THEN 
+      IF (iregion_bb(i)>0) THEN           ! LAND
+        ! SULFUR EMISSIONS
+        fluxso2bb(i) = scale_param_bb(iregion_bb(i)) * fracso2emis * &
+                (lmt_so2bb_l(i) + lmt_so2bb_h(i)) * &
+                (1. - pctsrf(i, is_oce)) * 1.e4 / RNAVO * masse_s * 1.e3       ! mgS/m2/s
+        ! SULPHATE EMISSIONS
+        fluxso4bb(i) = scale_param_bb(iregion_bb(i)) * (1 - fracso2emis) * &
+                (lmt_so2bb_l(i) + lmt_so2bb_h(i)) * &
+                (1. - pctsrf(i, is_oce)) * 1.e4 / RNAVO * masse_s * 1.e3       ! mgS/m2/s
+        ! BLACK CARBON EMISSIONS
+        fluxbcbb(i) = scale_param_bb(iregion_bb(i)) * &
+                (lmt_bcbb_l(i) + lmt_bcbb_h(i)) * 1.e4 * 1.e3  !mg/m2/s
+        ! ORGANIC MATTER EMISSIONS
+        fluxombb(i) = scale_param_bb(iregion_bb(i)) * &
+                (lmt_ombb_l(i) + lmt_ombb_h(i)) * 1.e4 * 1.e3  !mg/m2/s
+        ! BIOMASS BURNING EMISSIONS
+        fluxbb(i) = fluxbcbb(i) + fluxombb(i)
+      ENDIF
+      ! H2S EMISSIONS
+      fluxh2sbio(i) = lmt_h2sbio(i) * 1.e4 / RNAVO * masse_s * 1.e3      ! mgS/m2/s
+      fluxh2snff(i) = lmt_so2nff(i) * frach2sofso2 * &
+              1.e4 / RNAVO * masse_s * 1.e3         ! mgS/m2/s
+      ! SULFUR DIOXIDE EMISSIONS
+      fluxso2nff(i) = fracso2emis * lmt_so2nff(i) * 1.e4 / RNAVO * &
+              masse_s * 1.e3  ! mgS/m2/s
+      fluxso2vol(i) = (lmt_so2volc_cont(i) + lmt_so2volc_expl(i))  &
+              * 1.e4 / RNAVO * masse_s * 1.e3        ! mgS/m2/s
+      fluxso2ba(i) = lmt_so2ba(i) * 1.e4 / RNAVO * masse_s * 1.e3 * &
+              fracso2emis ! mgS/m2/s
+      fluxso2(i) = fluxso2ff(i) + fluxso2bb(i) + fluxso2nff(i) + &
+              fluxso2vol(i) + fluxso2ba(i)
+      ! DMS EMISSIONS
+      fluxdms(i) = (lmt_dms(i) + lmt_dmsbio(i))              &
+              * 1.e4 / RNAVO * masse_s * 1.e3          ! mgS/m2/s
+      ! SULPHATE EMISSIONS
+      fluxso4ba(i) = lmt_so2ba(i) * 1.e4 / RNAVO * masse_s * 1.e3        &
+              * (1 - fracso2emis) ! mgS/m2/s
+      fluxso4nff(i) = (1 - fracso2emis) * lmt_so2nff(i) * 1.e4 / RNAVO * &
+              masse_s * 1.e3  ! mgS/m2/s
+      fluxso4(i) = fluxso4ff(i) + fluxso4bb(i) + fluxso4ba(i) + fluxso4nff(i)
+      ! BLACK CARBON EMISSIONS
+
+      fluxbcnff(i) = lmt_bcnff(i) * 1.e4 * 1.e3  !mg/m2/s
+      fluxbcba(i) = lmt_bcba(i) * 1.e4 * 1.e3    !mg/m2/s
+      fluxbc(i) = fluxbcbb(i) + fluxbcff(i) + fluxbcnff(i) + fluxbcba(i)
+      ! ORGANIC MATTER EMISSIONS
+      fluxomnat(i) = lmt_omnat(i) * 1.e4 * 1.e3  !mg/m2/s
+      fluxomba(i) = lmt_omba(i) * 1.e4 * 1.e3  !mg/m2/s
+      fluxomnff(i) = lmt_omnff(i) * 1.e4 * 1.e3  !mg/m2/s
+      fluxom(i) = fluxombb(i) + fluxomff(i) + fluxomnat(i) + fluxomba(i) + &
+              fluxomnff(i)
+      ! DUST EMISSIONS
+      fluxdustec(i) = dust_ec(i) * 1.e6 ! old dust emission scheme
+      !JE20140605<<         old dust emission version
+      !         fluxddfine(i)=scale_param_dustacc(iregion_dust(i))
+      !     .                                  * dust_ec(i)*0.093*1.e6
+      !         fluxddcoa(i)=scale_param_dustcoa(iregion_dust(i))
+      !     .                                  * dust_ec(i)*0.905*1.e6
+      !         fluxdd(i)=fluxddfine(i)+fluxddcoa(i)
+      !JE20140605>>
+      fluxddfine(i) = flux_sparam_ddfine(i)
+      fluxddcoa(i) = flux_sparam_ddcoa(i)
+      fluxddsco(i) = flux_sparam_ddsco(i)
+      fluxdd(i) = fluxddfine(i) + fluxddcoa(i) + fluxddsco(i)
+      ! SEA SALT EMISSIONS
+      fluxssfine(i) = scale_param_ssacc * lmt_sea_salt(i, 1) * 1.e4 * 1.e3
+      fluxsscoa(i) = scale_param_sscoa * lmt_sea_salt(i, 2) * 1.e4 * 1.e3
+      fluxss(i) = fluxssfine(i) + fluxsscoa(i)
+    ENDDO
+
+    !      prepare outputs cvltr
+
+    DO itr = 1, nbtr
+      DO k = 1, klev
+        DO i = 1, klon
+          tmp_var(i, k) = d_tr_cv(i, k, itr)
+        ENDDO
+      ENDDO
+      CALL kg_to_cm3(pplay, t_seri, tmp_var)
+      DO k = 1, klev
+        DO i = 1, klon
+          d_tr_cv_o(i, k, itr) = tmp_var(i, k)  &
+                  / RNAVO * masse(itr) * 1.e3 * 1.e6 * zdz(i, k) / pdtphys
+        ENDDO
+      ENDDO
+    ENDDO
+    DO itr = 1, nbtr
+      DO k = 1, klev
+        DO i = 1, klon
+          tmp_var(i, k) = d_tr_trsp(i, k, itr)
+        ENDDO
+      ENDDO
+      CALL kg_to_cm3(pplay, t_seri, tmp_var)
+      DO k = 1, klev
+        DO i = 1, klon
+          d_tr_trsp_o(i, k, itr) = tmp_var(i, k)  &
+                  / RNAVO * masse(itr) * 1.e3 * 1.e6 * zdz(i, k) / pdtphys
+        ENDDO
+      ENDDO
+    ENDDO
+    DO itr = 1, nbtr
+      DO k = 1, klev
+        DO i = 1, klon
+          tmp_var(i, k) = d_tr_sscav(i, k, itr)
+        ENDDO
+      ENDDO
+      CALL kg_to_cm3(pplay, t_seri, tmp_var)
+      DO k = 1, klev
+        DO i = 1, klon
+          d_tr_sscav_o(i, k, itr) = tmp_var(i, k)  &
+                  / RNAVO * masse(itr) * 1.e3 * 1.e6 * zdz(i, k) / pdtphys
+        ENDDO
+      ENDDO
+    ENDDO
+    DO itr = 1, nbtr
+      DO k = 1, klev
+        DO i = 1, klon
+          tmp_var(i, k) = d_tr_sat(i, k, itr)
+        ENDDO
+      ENDDO
+      CALL kg_to_cm3(pplay, t_seri, tmp_var)
+      DO k = 1, klev
+        DO i = 1, klon
+          d_tr_sat_o(i, k, itr) = tmp_var(i, k)   &
+                  / RNAVO * masse(itr) * 1.e3 * 1.e6 * zdz(i, k) / pdtphys
+        ENDDO
+      ENDDO
+    ENDDO
+    DO itr = 1, nbtr
+      DO k = 1, klev
+        DO i = 1, klon
+          tmp_var(i, k) = d_tr_uscav(i, k, itr)
+        ENDDO
+      ENDDO
+      CALL kg_to_cm3(pplay, t_seri, tmp_var)
+      DO k = 1, klev
+        DO i = 1, klon
+          d_tr_uscav_o(i, k, itr) = tmp_var(i, k)  &
+                  / RNAVO * masse(itr) * 1.e3 * 1.e6 * zdz(i, k) / pdtphys
+        ENDDO
+      ENDDO
+    ENDDO
+    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+    DO itr = 1, nbtr
+      DO k = 1, klev
+        DO i = 1, klon
+          tmp_var(i, k) = d_tr_insc(i, k, itr)
+        ENDDO
+      ENDDO
+      CALL kg_to_cm3(pplay, t_seri, tmp_var)
+      DO k = 1, klev
+        DO i = 1, klon
+          d_tr_insc_o(i, k, itr) = tmp_var(i, k)  &
+                  / RNAVO * masse(itr) * 1.e3 * 1.e6 * zdz(i, k) / pdtphys
+        ENDDO
+      ENDDO
+    ENDDO
+
+    DO itr = 1, nbtr
+      DO k = 1, klev
+        DO i = 1, klon
+          tmp_var(i, k) = d_tr_bcscav(i, k, itr)
+        ENDDO
+      ENDDO
+      CALL kg_to_cm3(pplay, t_seri, tmp_var)
+      DO k = 1, klev
+        DO i = 1, klon
+          d_tr_bcscav_o(i, k, itr) = tmp_var(i, k)  &
+                  / RNAVO * masse(itr) * 1.e3 * 1.e6 * zdz(i, k) / pdtphys
+        ENDDO
+      ENDDO
+    ENDDO
+
+    DO itr = 1, nbtr
+      DO k = 1, klev
+        DO i = 1, klon
+          tmp_var(i, k) = d_tr_evapls(i, k, itr)
+        ENDDO
+      ENDDO
+      CALL kg_to_cm3(pplay, t_seri, tmp_var)
+      DO k = 1, klev
+        DO i = 1, klon
+          d_tr_evapls_o(i, k, itr) = tmp_var(i, k)  &
+                  / RNAVO * masse(itr) * 1.e3 * 1.e6 * zdz(i, k) / pdtphys
+        ENDDO
+      ENDDO
+    ENDDO
+
+    DO itr = 1, nbtr
+      DO k = 1, klev
+        DO i = 1, klon
+          tmp_var(i, k) = d_tr_ls(i, k, itr)
+        ENDDO
+      ENDDO
+      CALL kg_to_cm3(pplay, t_seri, tmp_var)
+      DO k = 1, klev
+        DO i = 1, klon
+          d_tr_ls_o(i, k, itr) = tmp_var(i, k)  &
+                  / RNAVO * masse(itr) * 1.e3 * 1.e6 * zdz(i, k) / pdtphys
+        ENDDO
+      ENDDO
+    ENDDO
+
+    DO itr = 1, nbtr
+      DO k = 1, klev
+        DO i = 1, klon
+          tmp_var(i, k) = d_tr_dyn(i, k, itr)
+        ENDDO
+      ENDDO
+      CALL kg_to_cm3(pplay, t_seri, tmp_var)
+      DO k = 1, klev
+        DO i = 1, klon
+          d_tr_dyn_o(i, k, itr) = tmp_var(i, k)  &
+                  / RNAVO * masse(itr) * 1.e3 * 1.e6 * zdz(i, k) / pdtphys
+        ENDDO
+      ENDDO
+    ENDDO
+
+    DO itr = 1, nbtr
+      DO k = 1, klev
+        DO i = 1, klon
+          tmp_var(i, k) = d_tr_cl(i, k, itr)
+        ENDDO
+      ENDDO
+      CALL kg_to_cm3(pplay, t_seri, tmp_var)
+      DO k = 1, klev
+        DO i = 1, klon
+          d_tr_cl_o(i, k, itr) = tmp_var(i, k)  &
+                  / RNAVO * masse(itr) * 1.e3 * 1.e6 * zdz(i, k) / pdtphys
+        ENDDO
+      ENDDO
+    ENDDO
+
+    DO itr = 1, nbtr
+      DO k = 1, klev
+        DO i = 1, klon
+          tmp_var(i, k) = d_tr_th(i, k, itr)
+        ENDDO
+      ENDDO
+      CALL kg_to_cm3(pplay, t_seri, tmp_var)
+      DO k = 1, klev
+        DO i = 1, klon
+          d_tr_th_o(i, k, itr) = tmp_var(i, k)  &
+                  / RNAVO * masse(itr) * 1.e3 * 1.e6 * zdz(i, k) / pdtphys
+        ENDDO
+      ENDDO
+    ENDDO
+    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+    DO itr = 1, nbtr
+      WRITE(str2, '(i2.2)') itr
+      DO i = 1, klon
+        his_dh(i, itr) = his_dhlsc(i, itr) + his_dhcon(i, itr) + &
+                his_dhbclsc(i, itr) + his_dhbccon(i, itr)
+
+      ENDDO
+    ENDDO
+
+    !AS: commenting out and deleting lines
+    !!      IF (ok_histrac) THEN
+    !!
+    !! SAVING VARIABLES IN TRACEUR
+    !!----- many lines deleted----
+    !!      ENDIF ! ok_histrac
+
+
+
+
+    !JE20141224
+    ! saving variables for output
+    ! 2D outputs
+    DO i = 1, klon
+      trm01(i) = 0.
+      trm02(i) = 0.
+      trm03(i) = 0.
+      trm04(i) = 0.
+      trm05(i) = 0.
+      sconc01(i) = 0.
+      sconc02(i) = 0.
+      sconc03(i) = 0.
+      sconc04(i) = 0.
+      sconc05(i) = 0.
+      flux01(i) = 0.
+      flux02(i) = 0.
+      flux03(i) = 0.
+      flux04(i) = 0.
+      flux05(i) = 0.
+      ds01(i) = 0.
+      ds02(i) = 0.
+      ds03(i) = 0.
+      ds04(i) = 0.
+      ds05(i) = 0.
+      dh01(i) = 0.
+      dh02(i) = 0.
+      dh03(i) = 0.
+      dh04(i) = 0.
+      dh05(i) = 0.
+      dtrconv01(i) = 0.
+      dtrconv02(i) = 0.
+      dtrconv03(i) = 0.
+      dtrconv04(i) = 0.
+      dtrconv05(i) = 0.
+      dtherm01(i) = 0.
+      dtherm02(i) = 0.
+      dtherm03(i) = 0.
+      dtherm04(i) = 0.
+      dtherm05(i) = 0.
+      dhkecv01(i) = 0.
+      dhkecv02(i) = 0.
+      dhkecv03(i) = 0.
+      dhkecv04(i) = 0.
+      dhkecv05(i) = 0.
+      d_tr_ds01(i) = 0.
+      d_tr_ds02(i) = 0.
+      d_tr_ds03(i) = 0.
+      d_tr_ds04(i) = 0.
+      d_tr_ds05(i) = 0.
+      dhkelsc01(i) = 0.
+      dhkelsc02(i) = 0.
+      dhkelsc03(i) = 0.
+      dhkelsc04(i) = 0.
+      dhkelsc05(i) = 0.
+      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+      if(id_prec>0)  trm01(i) = trm(i, id_prec)
+      if(id_fine>0)  trm02(i) = trm(i, id_fine)
+      if(id_coss>0)  trm03(i) = trm(i, id_coss)
+      if(id_codu>0)  trm04(i) = trm(i, id_codu)
+      if(id_scdu>0)  trm05(i) = trm(i, id_scdu)
+      if(id_prec>0)    sconc01(i) = sconc_seri(i, id_prec)
+      if(id_fine>0)    sconc02(i) = sconc_seri(i, id_fine)
+      if(id_coss>0)    sconc03(i) = sconc_seri(i, id_coss)
+      if(id_codu>0)    sconc04(i) = sconc_seri(i, id_codu)
+      if(id_scdu>0)    sconc05(i) = sconc_seri(i, id_scdu)
+      if(id_prec>0)    flux01(i) = flux_tr(i, id_prec)
+      if(id_fine>0)    flux02(i) = flux_tr(i, id_fine)
+      if(id_coss>0)    flux03(i) = flux_tr(i, id_coss)
+      if(id_codu>0)    flux04(i) = flux_tr(i, id_codu)
+      if(id_scdu>0)    flux05(i) = flux_tr(i, id_scdu)
+      if(id_prec>0)    ds01(i) = his_ds(i, id_prec)
+      if(id_fine>0)    ds02(i) = his_ds(i, id_fine)
+      if(id_coss>0)    ds03(i) = his_ds(i, id_coss)
+      if(id_codu>0)    ds04(i) = his_ds(i, id_codu)
+      if(id_scdu>0)    ds05(i) = his_ds(i, id_scdu)
+      if(id_prec>0)    dh01(i) = his_dh(i, id_prec)
+      if(id_fine>0)    dh02(i) = his_dh(i, id_fine)
+      if(id_coss>0)    dh03(i) = his_dh(i, id_coss)
+      if(id_codu>0)    dh04(i) = his_dh(i, id_codu)
+      if(id_scdu>0)    dh05(i) = his_dh(i, id_scdu)
+      if(id_prec>0)    dtrconv01(i) = dtrconv(i, id_prec)
+      if(id_fine>0)    dtrconv02(i) = dtrconv(i, id_fine)
+      if(id_coss>0)    dtrconv03(i) = dtrconv(i, id_coss)
+      if(id_codu>0)    dtrconv04(i) = dtrconv(i, id_codu)
+      if(id_scdu>0)    dtrconv05(i) = dtrconv(i, id_scdu)
+      if(id_prec>0)    dtherm01(i) = his_th(i, id_prec)
+      if(id_fine>0)    dtherm02(i) = his_th(i, id_fine)
+      if(id_coss>0)    dtherm03(i) = his_th(i, id_coss)
+      if(id_codu>0)    dtherm04(i) = his_th(i, id_codu)
+      if(id_scdu>0)    dtherm05(i) = his_th(i, id_scdu)
+      if(id_prec>0)    dhkecv01(i) = his_dhkecv(i, id_prec)
+      if(id_fine>0)    dhkecv02(i) = his_dhkecv(i, id_fine)
+      if(id_coss>0)    dhkecv03(i) = his_dhkecv(i, id_coss)
+      if(id_codu>0)    dhkecv04(i) = his_dhkecv(i, id_codu)
+      if(id_scdu>0)    dhkecv05(i) = his_dhkecv(i, id_scdu)
+      if(id_prec>0)    d_tr_ds01(i) = his_ds(i, id_prec)
+      if(id_fine>0)    d_tr_ds02(i) = his_ds(i, id_fine)
+      if(id_coss>0)    d_tr_ds03(i) = his_ds(i, id_coss)
+      if(id_codu>0)    d_tr_ds04(i) = his_ds(i, id_codu)
+      if(id_scdu>0)    d_tr_ds05(i) = his_ds(i, id_scdu)
+      if(id_prec>0)    dhkelsc01(i) = his_dhkelsc(i, id_prec)
+      if(id_fine>0)    dhkelsc02(i) = his_dhkelsc(i, id_fine)
+      if(id_coss>0)    dhkelsc03(i) = his_dhkelsc(i, id_coss)
+      if(id_codu>0)    dhkelsc04(i) = his_dhkelsc(i, id_codu)
+      if(id_scdu>0)    dhkelsc05(i) = his_dhkelsc(i, id_scdu)
+      u10m_ss(i) = u10m_ec(i)
+      v10m_ss(i) = v10m_ec(i)
+    ENDDO
+    ! 3D outs
+    DO i = 1, klon
+      DO k = 1, klev
+        d_tr_cv01(i, k) = 0.
+        d_tr_cv02(i, k) = 0.
+        d_tr_cv03(i, k) = 0.
+        d_tr_cv04(i, k) = 0.
+        d_tr_cv05(i, k) = 0.
+        d_tr_trsp01(i, k) = 0.
+        d_tr_trsp02(i, k) = 0.
+        d_tr_trsp03(i, k) = 0.
+        d_tr_trsp04(i, k) = 0.
+        d_tr_trsp05(i, k) = 0.
+        d_tr_sscav01(i, k) = 0.
+        d_tr_sscav02(i, k) = 0.
+        d_tr_sscav03(i, k) = 0.
+        d_tr_sscav04(i, k) = 0.
+        d_tr_sscav05(i, k) = 0.
+        d_tr_sat01(i, k) = 0.
+        d_tr_sat02(i, k) = 0.
+        d_tr_sat03(i, k) = 0.
+        d_tr_sat04(i, k) = 0.
+        d_tr_sat05(i, k) = 0.
+        d_tr_uscav01(i, k) = 0.
+        d_tr_uscav02(i, k) = 0.
+        d_tr_uscav03(i, k) = 0.
+        d_tr_uscav04(i, k) = 0.
+        d_tr_uscav05(i, k) = 0.
+        d_tr_insc01(i, k) = 0.!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+        d_tr_insc02(i, k) = 0.
+        d_tr_insc03(i, k) = 0.
+        d_tr_insc04(i, k) = 0.
+        d_tr_insc05(i, k) = 0.
+        d_tr_bcscav01(i, k) = 0.
+        d_tr_bcscav02(i, k) = 0.
+        d_tr_bcscav03(i, k) = 0.
+        d_tr_bcscav04(i, k) = 0.
+        d_tr_bcscav05(i, k) = 0.
+        d_tr_evapls01(i, k) = 0.
+        d_tr_evapls02(i, k) = 0.
+        d_tr_evapls03(i, k) = 0.
+        d_tr_evapls04(i, k) = 0.
+        d_tr_evapls05(i, k) = 0.
+        d_tr_ls01(i, k) = 0.
+        d_tr_ls02(i, k) = 0.
+        d_tr_ls03(i, k) = 0.
+        d_tr_ls04(i, k) = 0.
+        d_tr_ls05(i, k) = 0.!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+        d_tr_dyn01(i, k) = 0.
+        d_tr_dyn02(i, k) = 0.
+        d_tr_dyn03(i, k) = 0.
+        d_tr_dyn04(i, k) = 0.
+        d_tr_dyn05(i, k) = 0.!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+        d_tr_cl01(i, k) = 0.
+        d_tr_cl02(i, k) = 0.
+        d_tr_cl03(i, k) = 0.
+        d_tr_cl04(i, k) = 0.
+        d_tr_cl05(i, k) = 0.!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+        d_tr_th01(i, k) = 0.
+        d_tr_th02(i, k) = 0.
+        d_tr_th03(i, k) = 0.
+        d_tr_th04(i, k) = 0.
+        d_tr_th05(i, k) = 0.!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+      ENDDO
+    ENDDO
+
+    IF(1==0) THEN
       ! calcul in original trunk version; problem: budget not closed. Corrected in "ELSE"
-      DO i=1, klon
-        DO k=1,klev
-
-      if(id_prec>0)        d_tr_cv01(i,k)   =d_tr_cv_o(i,k,id_prec)
-      if(id_fine>0)        d_tr_cv02(i,k)   =d_tr_cv_o(i,k,id_fine)
-      if(id_coss>0)        d_tr_cv03(i,k)   =d_tr_cv_o(i,k,id_coss)
-      if(id_codu>0)        d_tr_cv04(i,k)   =d_tr_cv_o(i,k,id_codu)
-      if(id_scdu>0)        d_tr_cv05(i,k)   =d_tr_cv_o(i,k,id_scdu)
-      if(id_prec>0)        d_tr_trsp01(i,k) =d_tr_trsp_o(i,k,id_prec)
-      if(id_fine>0)        d_tr_trsp02(i,k) =d_tr_trsp_o(i,k,id_fine)
-      if(id_coss>0)        d_tr_trsp03(i,k) =d_tr_trsp_o(i,k,id_coss)
-      if(id_codu>0)        d_tr_trsp04(i,k) =d_tr_trsp_o(i,k,id_codu)
-      if(id_scdu>0)        d_tr_trsp05(i,k) =d_tr_trsp_o(i,k,id_scdu)
-      if(id_prec>0)        d_tr_sscav01(i,k)=d_tr_sscav_o(i,k,id_prec)
-      if(id_fine>0)        d_tr_sscav02(i,k)=d_tr_sscav_o(i,k,id_fine)
-      if(id_coss>0)        d_tr_sscav03(i,k)=d_tr_sscav_o(i,k,id_coss)
-      if(id_codu>0)        d_tr_sscav04(i,k)=d_tr_sscav_o(i,k,id_codu)
-      if(id_scdu>0)        d_tr_sscav05(i,k)=d_tr_sscav_o(i,k,id_scdu)
-      if(id_prec>0)        d_tr_sat01(i,k)  =d_tr_sat_o(i,k,id_prec)
-      if(id_fine>0)        d_tr_sat02(i,k)  =d_tr_sat_o(i,k,id_fine)
-      if(id_coss>0)        d_tr_sat03(i,k)  =d_tr_sat_o(i,k,id_coss)
-      if(id_codu>0)        d_tr_sat04(i,k)  =d_tr_sat_o(i,k,id_codu)
-      if(id_scdu>0)        d_tr_sat05(i,k)  =d_tr_sat_o(i,k,id_scdu)
-      if(id_prec>0)        d_tr_uscav01(i,k)=d_tr_uscav_o(i,k,id_prec)
-      if(id_fine>0)        d_tr_uscav02(i,k)=d_tr_uscav_o(i,k,id_fine)
-      if(id_coss>0)        d_tr_uscav03(i,k)=d_tr_uscav_o(i,k,id_coss)
-      if(id_codu>0)        d_tr_uscav04(i,k)=d_tr_uscav_o(i,k,id_codu)
-      if(id_scdu>0)        d_tr_uscav05(i,k)=d_tr_uscav_o(i,k,id_scdu)
-      if(id_prec>0)        d_tr_insc01(i,k)=d_tr_insc_o(i,k,id_prec)
-      if(id_fine>0)        d_tr_insc02(i,k)=d_tr_insc_o(i,k,id_fine)
-      if(id_coss>0)        d_tr_insc03(i,k)=d_tr_insc_o(i,k,id_coss)
-      if(id_codu>0)        d_tr_insc04(i,k)=d_tr_insc_o(i,k,id_codu)
-      if(id_scdu>0)        d_tr_insc05(i,k)=d_tr_insc_o(i,k,id_scdu)
-      if(id_prec>0)        d_tr_bcscav01(i,k)=d_tr_bcscav_o(i,k,id_prec)
-      if(id_fine>0)        d_tr_bcscav02(i,k)=d_tr_bcscav_o(i,k,id_fine)
-      if(id_coss>0)        d_tr_bcscav03(i,k)=d_tr_bcscav_o(i,k,id_coss)
-      if(id_codu>0)        d_tr_bcscav04(i,k)=d_tr_bcscav_o(i,k,id_codu)
-      if(id_scdu>0)        d_tr_bcscav05(i,k)=d_tr_bcscav_o(i,k,id_scdu)
-      if(id_prec>0)        d_tr_evapls01(i,k)=d_tr_evapls_o(i,k,id_prec)
-      if(id_fine>0)        d_tr_evapls02(i,k)=d_tr_evapls_o(i,k,id_fine)
-      if(id_coss>0)        d_tr_evapls03(i,k)=d_tr_evapls_o(i,k,id_coss)
-      if(id_codu>0)        d_tr_evapls04(i,k)=d_tr_evapls_o(i,k,id_codu)
-      if(id_scdu>0)        d_tr_evapls05(i,k)=d_tr_evapls_o(i,k,id_scdu)
-        ENDDO
-      ENDDO
-      ELSE ! correction pour fermeture de bilan, par FH dans les simus de Binta pour Habib
-      DO i=1, klon
-        DO k=1,klev
-      if(id_prec>0)        d_tr_cv01(i,k)   =d_tr_cv(i,k,id_prec)/pdtphys
-      if(id_fine>0)        d_tr_cv02(i,k)   =d_tr_cv(i,k,id_fine)/pdtphys
-      if(id_coss>0)        d_tr_cv03(i,k)   =d_tr_cv(i,k,id_coss)/pdtphys
-      if(id_codu>0)        d_tr_cv04(i,k)   =d_tr_cv(i,k,id_codu)/pdtphys
-      if(id_scdu>0)        d_tr_cv05(i,k)   =d_tr_cv(i,k,id_scdu)/pdtphys
-      if(id_prec>0)        d_tr_trsp01(i,k) =d_tr_trsp(i,k,id_prec)/pdtphys
-      if(id_fine>0)        d_tr_trsp02(i,k) =d_tr_trsp(i,k,id_fine)/pdtphys
-      if(id_coss>0)        d_tr_trsp03(i,k) =d_tr_trsp(i,k,id_coss)/pdtphys
-      if(id_codu>0)        d_tr_trsp04(i,k) =d_tr_trsp(i,k,id_codu)/pdtphys
-      if(id_scdu>0)        d_tr_trsp05(i,k) =d_tr_trsp(i,k,id_scdu)/pdtphys
-      if(id_prec>0)        d_tr_sscav01(i,k)=d_tr_sscav(i,k,id_prec)/pdtphys
-      if(id_fine>0)        d_tr_sscav02(i,k)=d_tr_sscav(i,k,id_fine)/pdtphys
-      if(id_coss>0)        d_tr_sscav03(i,k)=d_tr_sscav(i,k,id_coss)/pdtphys
-      if(id_codu>0)        d_tr_sscav04(i,k)=d_tr_sscav(i,k,id_codu)/pdtphys
-      if(id_scdu>0)        d_tr_sscav05(i,k)=d_tr_sscav(i,k,id_scdu)/pdtphys
-      if(id_prec>0)        d_tr_sat01(i,k)  =d_tr_sat(i,k,id_prec)/pdtphys
-      if(id_fine>0)        d_tr_sat02(i,k)  =d_tr_sat(i,k,id_fine)/pdtphys
-      if(id_coss>0)        d_tr_sat03(i,k)  =d_tr_sat(i,k,id_coss)/pdtphys
-      if(id_codu>0)        d_tr_sat04(i,k)  =d_tr_sat(i,k,id_codu)/pdtphys
-      if(id_scdu>0)        d_tr_sat05(i,k)  =d_tr_sat(i,k,id_scdu)/pdtphys
-      if(id_prec>0)        d_tr_uscav01(i,k)=d_tr_uscav(i,k,id_prec)/pdtphys
-      if(id_fine>0)        d_tr_uscav02(i,k)=d_tr_uscav(i,k,id_fine)/pdtphys
-      if(id_coss>0)        d_tr_uscav03(i,k)=d_tr_uscav(i,k,id_coss)/pdtphys
-      if(id_codu>0)        d_tr_uscav04(i,k)=d_tr_uscav(i,k,id_codu)/pdtphys
-      if(id_scdu>0)        d_tr_uscav05(i,k)=d_tr_uscav(i,k,id_scdu)/pdtphys
-      if(id_prec>0)        d_tr_insc01(i,k)=d_tr_insc(i,k,id_prec)/pdtphys
-      if(id_fine>0)        d_tr_insc02(i,k)=d_tr_insc(i,k,id_fine)/pdtphys
-      if(id_coss>0)        d_tr_insc03(i,k)=d_tr_insc(i,k,id_coss)/pdtphys
-      if(id_codu>0)        d_tr_insc04(i,k)=d_tr_insc(i,k,id_codu)/pdtphys
-      if(id_scdu>0)        d_tr_insc05(i,k)=d_tr_insc(i,k,id_scdu)/pdtphys
-      if(id_prec>0)        d_tr_bcscav01(i,k)=d_tr_bcscav(i,k,id_prec)/pdtphys
-      if(id_fine>0)        d_tr_bcscav02(i,k)=d_tr_bcscav(i,k,id_fine)/pdtphys
-      if(id_coss>0)        d_tr_bcscav03(i,k)=d_tr_bcscav(i,k,id_coss)/pdtphys
-      if(id_codu>0)        d_tr_bcscav04(i,k)=d_tr_bcscav(i,k,id_codu)/pdtphys
-      if(id_scdu>0)        d_tr_bcscav05(i,k)=d_tr_bcscav(i,k,id_scdu)/pdtphys
-      if(id_prec>0)        d_tr_evapls01(i,k)=d_tr_evapls(i,k,id_prec)/pdtphys
-      if(id_fine>0)        d_tr_evapls02(i,k)=d_tr_evapls(i,k,id_fine)/pdtphys
-      if(id_coss>0)        d_tr_evapls03(i,k)=d_tr_evapls(i,k,id_coss)/pdtphys
-      if(id_codu>0)        d_tr_evapls04(i,k)=d_tr_evapls(i,k,id_codu)/pdtphys
-      if(id_scdu>0)        d_tr_evapls05(i,k)=d_tr_evapls(i,k,id_scdu)/pdtphys
-        ENDDO
-      ENDDO
-      ENDIF 
-
-      IF(1==0) THEN  ! This "if" is as in original trunk
-      DO i=1, klon
-        DO k=1,klev
-      if(id_prec>0)        d_tr_ls01(i,k)=d_tr_ls_o(i,k,id_prec)
-      if(id_fine>0)        d_tr_ls02(i,k)=d_tr_ls_o(i,k,id_fine)
-      if(id_coss>0)        d_tr_ls03(i,k)=d_tr_ls_o(i,k,id_coss)
-      if(id_codu>0)        d_tr_ls04(i,k)=d_tr_ls_o(i,k,id_codu)
-      if(id_scdu>0)        d_tr_ls05(i,k)=d_tr_ls_o(i,k,id_scdu)
-      if(id_prec>0)        d_tr_dyn01(i,k)=d_tr_dyn_o(i,k,id_prec)
-      if(id_fine>0)        d_tr_dyn02(i,k)=d_tr_dyn_o(i,k,id_fine)
-      if(id_coss>0)        d_tr_dyn03(i,k)=d_tr_dyn_o(i,k,id_coss)
-      if(id_codu>0)        d_tr_dyn04(i,k)=d_tr_dyn_o(i,k,id_codu)
-      if(id_scdu>0)        d_tr_dyn05(i,k)=d_tr_dyn_o(i,k,id_scdu)
-      if(id_prec>0)        d_tr_cl01(i,k)=d_tr_cl_o(i,k,id_prec)
-      if(id_fine>0)        d_tr_cl02(i,k)=d_tr_cl_o(i,k,id_fine)
-      if(id_coss>0)        d_tr_cl03(i,k)=d_tr_cl_o(i,k,id_coss)
-      if(id_codu>0)        d_tr_cl04(i,k)=d_tr_cl_o(i,k,id_codu)
-      if(id_scdu>0)        d_tr_cl05(i,k)=d_tr_cl_o(i,k,id_scdu)
-      if(id_prec>0)        d_tr_th01(i,k)=d_tr_th_o(i,k,id_prec)
-      if(id_fine>0)        d_tr_th02(i,k)=d_tr_th_o(i,k,id_fine)
-      if(id_coss>0)        d_tr_th03(i,k)=d_tr_th_o(i,k,id_coss)
-      if(id_codu>0)        d_tr_th04(i,k)=d_tr_th_o(i,k,id_codu)
-      if(id_scdu>0)        d_tr_th05(i,k)=d_tr_th_o(i,k,id_scdu)
-        ENDDO
-      ENDDO
-      ELSE
-      DO i=1, klon
-        DO k=1,klev
-      if(id_prec>0)        d_tr_ls01(i,k)=d_tr_ls(i,k,id_prec)/pdtphys
-      if(id_fine>0)        d_tr_ls02(i,k)=d_tr_ls(i,k,id_fine)/pdtphys
-      if(id_coss>0)        d_tr_ls03(i,k)=d_tr_ls(i,k,id_coss)/pdtphys
-      if(id_codu>0)        d_tr_ls04(i,k)=d_tr_ls(i,k,id_codu)/pdtphys
-      if(id_scdu>0)        d_tr_ls05(i,k)=d_tr_ls(i,k,id_scdu)/pdtphys
-      if(id_prec>0)        d_tr_dyn01(i,k)=d_tr_dyn(i,k,id_prec)/pdtphys
-      if(id_fine>0)        d_tr_dyn02(i,k)=d_tr_dyn(i,k,id_fine)/pdtphys
-      if(id_coss>0)        d_tr_dyn03(i,k)=d_tr_dyn(i,k,id_coss)/pdtphys
-      if(id_codu>0)        d_tr_dyn04(i,k)=d_tr_dyn(i,k,id_codu)/pdtphys
-      if(id_scdu>0)        d_tr_dyn05(i,k)=d_tr_dyn(i,k,id_scdu)/pdtphys
-      if(id_prec>0)        d_tr_cl01(i,k)=d_tr_cl(i,k,id_prec)/pdtphys
-      if(id_fine>0)        d_tr_cl02(i,k)=d_tr_cl(i,k,id_fine)/pdtphys
-      if(id_coss>0)        d_tr_cl03(i,k)=d_tr_cl(i,k,id_coss)/pdtphys
-      if(id_codu>0)        d_tr_cl04(i,k)=d_tr_cl(i,k,id_codu)/pdtphys
-      if(id_scdu>0)        d_tr_cl05(i,k)=d_tr_cl(i,k,id_scdu)/pdtphys
-      if(id_prec>0)        d_tr_th01(i,k)=d_tr_th(i,k,id_prec)/pdtphys
-      if(id_fine>0)        d_tr_th02(i,k)=d_tr_th(i,k,id_fine)/pdtphys
-      if(id_coss>0)        d_tr_th03(i,k)=d_tr_th(i,k,id_coss)/pdtphys
-      if(id_codu>0)        d_tr_th04(i,k)=d_tr_th(i,k,id_codu)/pdtphys
-      if(id_scdu>0)        d_tr_th05(i,k)=d_tr_th(i,k,id_scdu)/pdtphys
-        ENDDO
-      ENDDO
-      ENDIF
-     
-
-      IF (logitime) THEN
-      CALL SYSTEM_CLOCK(COUNT=clock_end)
-
-      dife=clock_end-clock_start
-      ti_outs=dife*MAX(0,SIGN(1,dife))   &
-      +(dife+clock_per_max)*MAX(0,SIGN(1,-dife))
-      tia_outs=tia_outs+REAL(ti_outs)/REAL(clock_rate)
-      ENDIF
-
-      IF (logitime) THEN
-      CALL SYSTEM_CLOCK(COUNT=clock_end)
-
-      dife=clock_end-clock_start_spla
-      ti_spla=dife*MAX(0,SIGN(1,dife)) &
-      +(dife+clock_per_max)*MAX(0,SIGN(1,-dife))
-
-
-      tia_spla=tia_spla+REAL(ti_spla)/REAL(clock_rate)
-  print *,'times for this timestep:timeproc,timeproc/time_pytracr_spl-'
-     print *,'time spla',REAL(ti_spla)/REAL(clock_rate)                &
-      ,REAL(ti_spla)/REAL(ti_spla)                                      
-     print *,'time init',REAL(ti_init)/REAL(clock_rate)                &
-      ,REAL(ti_init)/REAL(ti_spla)                                      
-     print *,'time inittype',REAL(ti_inittype)/REAL(clock_rate)        &
-      ,REAL(ti_inittype)/REAL(ti_spla)                                  
-     print *,'time inittwrite',REAL(ti_inittwrite)/REAL(clock_rate)    &
-      ,REAL(ti_inittwrite)/REAL(ti_spla)                                
-     print *,'time emis',REAL(ti_emis)/REAL(clock_rate)                &
-      ,REAL(ti_emis)/REAL(ti_spla)                                      
-     print *,'time depo ',REAL(ti_depo)/REAL(clock_rate)               &
-      ,REAL(ti_depo)/REAL(ti_spla)                                      
-     print *,'time cltr',REAL(ti_cltr)/REAL(clock_rate)                &
-      ,REAL(ti_cltr)/REAL(ti_spla)                                      
-     print *,'time ther',REAL(ti_ther)/REAL(clock_rate)                &
-      ,REAL(ti_ther)/REAL(ti_spla)                                      
-     print *,'time sedi',REAL(ti_sedi)/REAL(clock_rate)                &
-      ,REAL(ti_sedi)/REAL(ti_spla)                                      
-     print *,'time gas to part',REAL(ti_gasp)/REAL(clock_rate)         &
-      ,REAL(ti_gasp)/REAL(ti_spla)                                      
-     print *,'time AP wet',REAL(ti_wetap)/REAL(clock_rate)             &
-      ,REAL(ti_wetap)/REAL(ti_spla)                                     
-     print *,'time convective',REAL(ti_cvltr)/REAL(clock_rate)         &
-      ,REAL(ti_cvltr)/REAL(ti_spla)                                     
-     print *,'time NP lsc scav',REAL(ti_lscs)/REAL(clock_rate)         &
-      ,REAL(ti_lscs)/REAL(ti_spla)                                      
-     print *,'time opt,brdn,etc',REAL(ti_brop)/REAL(clock_rate)        &
-      ,REAL(ti_brop)/REAL(ti_spla)                                      
-     print *,'time outputs',REAL(ti_outs)/REAL(clock_rate)             &
-      ,REAL(ti_outs)/REAL(ti_spla)
-
-
-  print *,'--time accumulated: time proc, time proc/time phytracr_spl--'
-      print *,'time spla',tia_spla
-      print *,'time init',tia_init,tia_init/tia_spla
-      print *,'time inittype',tia_inittype,tia_inittype/tia_spla
-      print *,'time inittwrite',tia_inittwrite,tia_inittwrite/tia_spla
-      print *,'time emis',tia_emis,tia_emis/tia_spla
-      print *,'time depo',tia_depo,tia_depo/tia_spla
-      print *,'time cltr',tia_cltr,tia_cltr/tia_spla
-      print *,'time ther',tia_ther,tia_ther/tia_spla
-      print *,'time sedi',tia_sedi,tia_sedi/tia_spla
-      print *,'time gas to part',tia_gasp,tia_gasp/tia_spla
-      print *,'time AP wet',tia_wetap,tia_wetap/tia_spla
-      print *,'time convective',tia_cvltr,tia_cvltr/tia_spla
-      print *,'time NP lsc scav',tia_lscs,tia_lscs/tia_spla
-      print *,'time opt,brdn,etc',tia_brop,tia_brop/tia_spla
-      print *,'time outputs',tia_outs,tia_outs/tia_spla
-
-
-
-      dife=clock_end_outphytracr-clock_start_outphytracr
-      ti_nophytracr=dife*MAX(0,SIGN(1,dife))  &
-      +(dife+clock_per_max)*MAX(0,SIGN(1,-dife))
-      tia_nophytracr=tia_nophytracr+REAL(ti_nophytracr)/REAL(clock_rate)
-      print *,'Time outside phytracr; Time accum outside phytracr'
-      print*,REAL(ti_nophytracr)/REAL(clock_rate),tia_nophytracr
-
-      clock_start_outphytracr=clock_end
-
-      ENDIF      
-      print *,'END PHYTRACR_SPL '
-  print *,'lmt_so2ff_l FIN' , MINVAL(lmt_so2ff_l), MAXVAL(lmt_so2ff_l)
-
-!      CALL abort_gcm('TEST1', 'OK1', 1)
-
-      RETURN
-      END SUBROUTINE phytracr_spl
- 
-      SUBROUTINE readregionsdims2_spl(nbreg,fileregions)
-
-      USE mod_grid_phy_lmdz
-      USE mod_phys_lmdz_para
-
-      IMPLICIT NONE
-      CHARACTER*800 fileregions
-      CHARACTER*800 auxstr
-      INTEGER nbreg
- 
-      IF (is_mpi_root .AND. is_omp_root) THEN 
-
-      OPEN (UNIT=1,FILE=trim(adjustl(fileregions)))
-      READ(1,'(a)') auxstr
-      READ(1,'(i10)') nbreg
-      CLOSE(UNIT=1)
-      ENDIF
-      CALL bcast(nbreg)
-
-      END SUBROUTINE readregionsdims2_spl
-
-      SUBROUTINE readregionsdims_spl(nbreg_ind,fileregionsdimsind,   &
-                                    nbreg_dust,fileregionsdimsdust,  &
-                                    nbreg_bb,fileregionsdimsbb)     
-      USE mod_grid_phy_lmdz
-      USE mod_phys_lmdz_para
-
-      IMPLICIT NONE
-      CHARACTER*800 fileregionsdimsind
-      CHARACTER*800 fileregionsdimsdust
-      CHARACTER*800 fileregionsdimsbb
-      CHARACTER*800 auxstr
-      INTEGER nbreg_ind,nbreg_dust,nbreg_bb
- 
-      IF (is_mpi_root .AND. is_omp_root) THEN 
-
-      OPEN (UNIT=1,FILE=trim(adjustl(fileregionsdimsind)))
-      READ(1,'(a)') auxstr
-      READ(1,'(i10)') nbreg_ind
-      CLOSE(UNIT=1)
-
-      OPEN (UNIT=1,FILE=trim(adjustl(fileregionsdimsdust)))
-      READ(1,'(a)') auxstr
-      READ(1,'(i10)') nbreg_dust
-      CLOSE(UNIT=1)
-
-      OPEN (UNIT=1,FILE=trim(adjustl(fileregionsdimsbb)))
-      READ(1,'(a)') auxstr
-      READ(1,'(i10)') nbreg_bb
-      CLOSE(UNIT=1)
-      
-
-      ENDIF
-      CALL bcast(nbreg_ind)
-      CALL bcast(nbreg_dust)
-      CALL bcast(nbreg_bb)
-
-      END SUBROUTINE readregionsdims_spl
-
-      SUBROUTINE readregions_spl(iregion,filenameregion)
-      USE dimphy
-      USE mod_grid_phy_lmdz
-      USE mod_phys_lmdz_para
-
-      IMPLICIT NONE
-      CHARACTER*(*) filenameregion
-      INTEGER iregion(klon)
-      INTEGER iregion_glo(klon_glo)
-      INTEGER k
-     
-      IF (is_mpi_root .AND. is_omp_root) THEN
-
-      print *,trim(adjustl(filenameregion))
-      OPEN(1,file=trim(adjustl(filenameregion)))
-      DO k=1,klon_glo
-      READ(1,'(i10)') iregion_glo(k)
-      ENDDO
-      CLOSE(UNIT=1)
-      ENDIF
-      CALL scatter(iregion_glo,iregion)
-
-      END SUBROUTINE readregions_spl
-
-!! AS: SUBROUTINE readscaleparams_spl pas appellee
-      SUBROUTINE readscaleparams_spl(scale_param, nbreg, &
-                                             filescaleparams)
-      USE mod_grid_phy_lmdz
-      USE mod_phys_lmdz_para
-      IMPLICIT NONE
-
-      CHARACTER*800 filescaleparams
-      INTEGER nbreg
-      REAL scale_param(nbreg)
-      INTEGER k
-
-      IF (is_mpi_root .AND. is_omp_root) THEN
-      OPEN(1,file=trim(adjustl(filescaleparams)),form='unformatted')
-      do k=1,nbreg
+      DO i = 1, klon
+        DO k = 1, klev
+
+          if(id_prec>0)        d_tr_cv01(i, k) = d_tr_cv_o(i, k, id_prec)
+          if(id_fine>0)        d_tr_cv02(i, k) = d_tr_cv_o(i, k, id_fine)
+          if(id_coss>0)        d_tr_cv03(i, k) = d_tr_cv_o(i, k, id_coss)
+          if(id_codu>0)        d_tr_cv04(i, k) = d_tr_cv_o(i, k, id_codu)
+          if(id_scdu>0)        d_tr_cv05(i, k) = d_tr_cv_o(i, k, id_scdu)
+          if(id_prec>0)        d_tr_trsp01(i, k) = d_tr_trsp_o(i, k, id_prec)
+          if(id_fine>0)        d_tr_trsp02(i, k) = d_tr_trsp_o(i, k, id_fine)
+          if(id_coss>0)        d_tr_trsp03(i, k) = d_tr_trsp_o(i, k, id_coss)
+          if(id_codu>0)        d_tr_trsp04(i, k) = d_tr_trsp_o(i, k, id_codu)
+          if(id_scdu>0)        d_tr_trsp05(i, k) = d_tr_trsp_o(i, k, id_scdu)
+          if(id_prec>0)        d_tr_sscav01(i, k) = d_tr_sscav_o(i, k, id_prec)
+          if(id_fine>0)        d_tr_sscav02(i, k) = d_tr_sscav_o(i, k, id_fine)
+          if(id_coss>0)        d_tr_sscav03(i, k) = d_tr_sscav_o(i, k, id_coss)
+          if(id_codu>0)        d_tr_sscav04(i, k) = d_tr_sscav_o(i, k, id_codu)
+          if(id_scdu>0)        d_tr_sscav05(i, k) = d_tr_sscav_o(i, k, id_scdu)
+          if(id_prec>0)        d_tr_sat01(i, k) = d_tr_sat_o(i, k, id_prec)
+          if(id_fine>0)        d_tr_sat02(i, k) = d_tr_sat_o(i, k, id_fine)
+          if(id_coss>0)        d_tr_sat03(i, k) = d_tr_sat_o(i, k, id_coss)
+          if(id_codu>0)        d_tr_sat04(i, k) = d_tr_sat_o(i, k, id_codu)
+          if(id_scdu>0)        d_tr_sat05(i, k) = d_tr_sat_o(i, k, id_scdu)
+          if(id_prec>0)        d_tr_uscav01(i, k) = d_tr_uscav_o(i, k, id_prec)
+          if(id_fine>0)        d_tr_uscav02(i, k) = d_tr_uscav_o(i, k, id_fine)
+          if(id_coss>0)        d_tr_uscav03(i, k) = d_tr_uscav_o(i, k, id_coss)
+          if(id_codu>0)        d_tr_uscav04(i, k) = d_tr_uscav_o(i, k, id_codu)
+          if(id_scdu>0)        d_tr_uscav05(i, k) = d_tr_uscav_o(i, k, id_scdu)
+          if(id_prec>0)        d_tr_insc01(i, k) = d_tr_insc_o(i, k, id_prec)
+          if(id_fine>0)        d_tr_insc02(i, k) = d_tr_insc_o(i, k, id_fine)
+          if(id_coss>0)        d_tr_insc03(i, k) = d_tr_insc_o(i, k, id_coss)
+          if(id_codu>0)        d_tr_insc04(i, k) = d_tr_insc_o(i, k, id_codu)
+          if(id_scdu>0)        d_tr_insc05(i, k) = d_tr_insc_o(i, k, id_scdu)
+          if(id_prec>0)        d_tr_bcscav01(i, k) = d_tr_bcscav_o(i, k, id_prec)
+          if(id_fine>0)        d_tr_bcscav02(i, k) = d_tr_bcscav_o(i, k, id_fine)
+          if(id_coss>0)        d_tr_bcscav03(i, k) = d_tr_bcscav_o(i, k, id_coss)
+          if(id_codu>0)        d_tr_bcscav04(i, k) = d_tr_bcscav_o(i, k, id_codu)
+          if(id_scdu>0)        d_tr_bcscav05(i, k) = d_tr_bcscav_o(i, k, id_scdu)
+          if(id_prec>0)        d_tr_evapls01(i, k) = d_tr_evapls_o(i, k, id_prec)
+          if(id_fine>0)        d_tr_evapls02(i, k) = d_tr_evapls_o(i, k, id_fine)
+          if(id_coss>0)        d_tr_evapls03(i, k) = d_tr_evapls_o(i, k, id_coss)
+          if(id_codu>0)        d_tr_evapls04(i, k) = d_tr_evapls_o(i, k, id_codu)
+          if(id_scdu>0)        d_tr_evapls05(i, k) = d_tr_evapls_o(i, k, id_scdu)
+        ENDDO
+      ENDDO
+    ELSE ! correction pour fermeture de bilan, par FH dans les simus de Binta pour Habib
+      DO i = 1, klon
+        DO k = 1, klev
+          if(id_prec>0)        d_tr_cv01(i, k) = d_tr_cv(i, k, id_prec) / pdtphys
+          if(id_fine>0)        d_tr_cv02(i, k) = d_tr_cv(i, k, id_fine) / pdtphys
+          if(id_coss>0)        d_tr_cv03(i, k) = d_tr_cv(i, k, id_coss) / pdtphys
+          if(id_codu>0)        d_tr_cv04(i, k) = d_tr_cv(i, k, id_codu) / pdtphys
+          if(id_scdu>0)        d_tr_cv05(i, k) = d_tr_cv(i, k, id_scdu) / pdtphys
+          if(id_prec>0)        d_tr_trsp01(i, k) = d_tr_trsp(i, k, id_prec) / pdtphys
+          if(id_fine>0)        d_tr_trsp02(i, k) = d_tr_trsp(i, k, id_fine) / pdtphys
+          if(id_coss>0)        d_tr_trsp03(i, k) = d_tr_trsp(i, k, id_coss) / pdtphys
+          if(id_codu>0)        d_tr_trsp04(i, k) = d_tr_trsp(i, k, id_codu) / pdtphys
+          if(id_scdu>0)        d_tr_trsp05(i, k) = d_tr_trsp(i, k, id_scdu) / pdtphys
+          if(id_prec>0)        d_tr_sscav01(i, k) = d_tr_sscav(i, k, id_prec) / pdtphys
+          if(id_fine>0)        d_tr_sscav02(i, k) = d_tr_sscav(i, k, id_fine) / pdtphys
+          if(id_coss>0)        d_tr_sscav03(i, k) = d_tr_sscav(i, k, id_coss) / pdtphys
+          if(id_codu>0)        d_tr_sscav04(i, k) = d_tr_sscav(i, k, id_codu) / pdtphys
+          if(id_scdu>0)        d_tr_sscav05(i, k) = d_tr_sscav(i, k, id_scdu) / pdtphys
+          if(id_prec>0)        d_tr_sat01(i, k) = d_tr_sat(i, k, id_prec) / pdtphys
+          if(id_fine>0)        d_tr_sat02(i, k) = d_tr_sat(i, k, id_fine) / pdtphys
+          if(id_coss>0)        d_tr_sat03(i, k) = d_tr_sat(i, k, id_coss) / pdtphys
+          if(id_codu>0)        d_tr_sat04(i, k) = d_tr_sat(i, k, id_codu) / pdtphys
+          if(id_scdu>0)        d_tr_sat05(i, k) = d_tr_sat(i, k, id_scdu) / pdtphys
+          if(id_prec>0)        d_tr_uscav01(i, k) = d_tr_uscav(i, k, id_prec) / pdtphys
+          if(id_fine>0)        d_tr_uscav02(i, k) = d_tr_uscav(i, k, id_fine) / pdtphys
+          if(id_coss>0)        d_tr_uscav03(i, k) = d_tr_uscav(i, k, id_coss) / pdtphys
+          if(id_codu>0)        d_tr_uscav04(i, k) = d_tr_uscav(i, k, id_codu) / pdtphys
+          if(id_scdu>0)        d_tr_uscav05(i, k) = d_tr_uscav(i, k, id_scdu) / pdtphys
+          if(id_prec>0)        d_tr_insc01(i, k) = d_tr_insc(i, k, id_prec) / pdtphys
+          if(id_fine>0)        d_tr_insc02(i, k) = d_tr_insc(i, k, id_fine) / pdtphys
+          if(id_coss>0)        d_tr_insc03(i, k) = d_tr_insc(i, k, id_coss) / pdtphys
+          if(id_codu>0)        d_tr_insc04(i, k) = d_tr_insc(i, k, id_codu) / pdtphys
+          if(id_scdu>0)        d_tr_insc05(i, k) = d_tr_insc(i, k, id_scdu) / pdtphys
+          if(id_prec>0)        d_tr_bcscav01(i, k) = d_tr_bcscav(i, k, id_prec) / pdtphys
+          if(id_fine>0)        d_tr_bcscav02(i, k) = d_tr_bcscav(i, k, id_fine) / pdtphys
+          if(id_coss>0)        d_tr_bcscav03(i, k) = d_tr_bcscav(i, k, id_coss) / pdtphys
+          if(id_codu>0)        d_tr_bcscav04(i, k) = d_tr_bcscav(i, k, id_codu) / pdtphys
+          if(id_scdu>0)        d_tr_bcscav05(i, k) = d_tr_bcscav(i, k, id_scdu) / pdtphys
+          if(id_prec>0)        d_tr_evapls01(i, k) = d_tr_evapls(i, k, id_prec) / pdtphys
+          if(id_fine>0)        d_tr_evapls02(i, k) = d_tr_evapls(i, k, id_fine) / pdtphys
+          if(id_coss>0)        d_tr_evapls03(i, k) = d_tr_evapls(i, k, id_coss) / pdtphys
+          if(id_codu>0)        d_tr_evapls04(i, k) = d_tr_evapls(i, k, id_codu) / pdtphys
+          if(id_scdu>0)        d_tr_evapls05(i, k) = d_tr_evapls(i, k, id_scdu) / pdtphys
+        ENDDO
+      ENDDO
+    ENDIF
+
+    IF(1==0) THEN  ! This "if" is as in original trunk
+      DO i = 1, klon
+        DO k = 1, klev
+          if(id_prec>0)        d_tr_ls01(i, k) = d_tr_ls_o(i, k, id_prec)
+          if(id_fine>0)        d_tr_ls02(i, k) = d_tr_ls_o(i, k, id_fine)
+          if(id_coss>0)        d_tr_ls03(i, k) = d_tr_ls_o(i, k, id_coss)
+          if(id_codu>0)        d_tr_ls04(i, k) = d_tr_ls_o(i, k, id_codu)
+          if(id_scdu>0)        d_tr_ls05(i, k) = d_tr_ls_o(i, k, id_scdu)
+          if(id_prec>0)        d_tr_dyn01(i, k) = d_tr_dyn_o(i, k, id_prec)
+          if(id_fine>0)        d_tr_dyn02(i, k) = d_tr_dyn_o(i, k, id_fine)
+          if(id_coss>0)        d_tr_dyn03(i, k) = d_tr_dyn_o(i, k, id_coss)
+          if(id_codu>0)        d_tr_dyn04(i, k) = d_tr_dyn_o(i, k, id_codu)
+          if(id_scdu>0)        d_tr_dyn05(i, k) = d_tr_dyn_o(i, k, id_scdu)
+          if(id_prec>0)        d_tr_cl01(i, k) = d_tr_cl_o(i, k, id_prec)
+          if(id_fine>0)        d_tr_cl02(i, k) = d_tr_cl_o(i, k, id_fine)
+          if(id_coss>0)        d_tr_cl03(i, k) = d_tr_cl_o(i, k, id_coss)
+          if(id_codu>0)        d_tr_cl04(i, k) = d_tr_cl_o(i, k, id_codu)
+          if(id_scdu>0)        d_tr_cl05(i, k) = d_tr_cl_o(i, k, id_scdu)
+          if(id_prec>0)        d_tr_th01(i, k) = d_tr_th_o(i, k, id_prec)
+          if(id_fine>0)        d_tr_th02(i, k) = d_tr_th_o(i, k, id_fine)
+          if(id_coss>0)        d_tr_th03(i, k) = d_tr_th_o(i, k, id_coss)
+          if(id_codu>0)        d_tr_th04(i, k) = d_tr_th_o(i, k, id_codu)
+          if(id_scdu>0)        d_tr_th05(i, k) = d_tr_th_o(i, k, id_scdu)
+        ENDDO
+      ENDDO
+    ELSE
+      DO i = 1, klon
+        DO k = 1, klev
+          if(id_prec>0)        d_tr_ls01(i, k) = d_tr_ls(i, k, id_prec) / pdtphys
+          if(id_fine>0)        d_tr_ls02(i, k) = d_tr_ls(i, k, id_fine) / pdtphys
+          if(id_coss>0)        d_tr_ls03(i, k) = d_tr_ls(i, k, id_coss) / pdtphys
+          if(id_codu>0)        d_tr_ls04(i, k) = d_tr_ls(i, k, id_codu) / pdtphys
+          if(id_scdu>0)        d_tr_ls05(i, k) = d_tr_ls(i, k, id_scdu) / pdtphys
+          if(id_prec>0)        d_tr_dyn01(i, k) = d_tr_dyn(i, k, id_prec) / pdtphys
+          if(id_fine>0)        d_tr_dyn02(i, k) = d_tr_dyn(i, k, id_fine) / pdtphys
+          if(id_coss>0)        d_tr_dyn03(i, k) = d_tr_dyn(i, k, id_coss) / pdtphys
+          if(id_codu>0)        d_tr_dyn04(i, k) = d_tr_dyn(i, k, id_codu) / pdtphys
+          if(id_scdu>0)        d_tr_dyn05(i, k) = d_tr_dyn(i, k, id_scdu) / pdtphys
+          if(id_prec>0)        d_tr_cl01(i, k) = d_tr_cl(i, k, id_prec) / pdtphys
+          if(id_fine>0)        d_tr_cl02(i, k) = d_tr_cl(i, k, id_fine) / pdtphys
+          if(id_coss>0)        d_tr_cl03(i, k) = d_tr_cl(i, k, id_coss) / pdtphys
+          if(id_codu>0)        d_tr_cl04(i, k) = d_tr_cl(i, k, id_codu) / pdtphys
+          if(id_scdu>0)        d_tr_cl05(i, k) = d_tr_cl(i, k, id_scdu) / pdtphys
+          if(id_prec>0)        d_tr_th01(i, k) = d_tr_th(i, k, id_prec) / pdtphys
+          if(id_fine>0)        d_tr_th02(i, k) = d_tr_th(i, k, id_fine) / pdtphys
+          if(id_coss>0)        d_tr_th03(i, k) = d_tr_th(i, k, id_coss) / pdtphys
+          if(id_codu>0)        d_tr_th04(i, k) = d_tr_th(i, k, id_codu) / pdtphys
+          if(id_scdu>0)        d_tr_th05(i, k) = d_tr_th(i, k, id_scdu) / pdtphys
+        ENDDO
+      ENDDO
+    ENDIF
+
+    IF (logitime) THEN
+      CALL SYSTEM_CLOCK(COUNT = clock_end)
+
+      dife = clock_end - clock_start
+      ti_outs = dife * MAX(0, SIGN(1, dife))   &
+              + (dife + clock_per_max) * MAX(0, SIGN(1, -dife))
+      tia_outs = tia_outs + REAL(ti_outs) / REAL(clock_rate)
+    ENDIF
+
+    IF (logitime) THEN
+      CALL SYSTEM_CLOCK(COUNT = clock_end)
+
+      dife = clock_end - clock_start_spla
+      ti_spla = dife * MAX(0, SIGN(1, dife)) &
+              + (dife + clock_per_max) * MAX(0, SIGN(1, -dife))
+
+      tia_spla = tia_spla + REAL(ti_spla) / REAL(clock_rate)
+      print *, 'times for this timestep:timeproc,timeproc/time_pytracr_spl-'
+      print *, 'time spla', REAL(ti_spla) / REAL(clock_rate)                &
+              , REAL(ti_spla) / REAL(ti_spla)
+      print *, 'time init', REAL(ti_init) / REAL(clock_rate)                &
+              , REAL(ti_init) / REAL(ti_spla)
+      print *, 'time inittype', REAL(ti_inittype) / REAL(clock_rate)        &
+              , REAL(ti_inittype) / REAL(ti_spla)
+      print *, 'time inittwrite', REAL(ti_inittwrite) / REAL(clock_rate)    &
+              , REAL(ti_inittwrite) / REAL(ti_spla)
+      print *, 'time emis', REAL(ti_emis) / REAL(clock_rate)                &
+              , REAL(ti_emis) / REAL(ti_spla)
+      print *, 'time depo ', REAL(ti_depo) / REAL(clock_rate)               &
+              , REAL(ti_depo) / REAL(ti_spla)
+      print *, 'time cltr', REAL(ti_cltr) / REAL(clock_rate)                &
+              , REAL(ti_cltr) / REAL(ti_spla)
+      print *, 'time ther', REAL(ti_ther) / REAL(clock_rate)                &
+              , REAL(ti_ther) / REAL(ti_spla)
+      print *, 'time sedi', REAL(ti_sedi) / REAL(clock_rate)                &
+              , REAL(ti_sedi) / REAL(ti_spla)
+      print *, 'time gas to part', REAL(ti_gasp) / REAL(clock_rate)         &
+              , REAL(ti_gasp) / REAL(ti_spla)
+      print *, 'time AP wet', REAL(ti_wetap) / REAL(clock_rate)             &
+              , REAL(ti_wetap) / REAL(ti_spla)
+      print *, 'time convective', REAL(ti_cvltr) / REAL(clock_rate)         &
+              , REAL(ti_cvltr) / REAL(ti_spla)
+      print *, 'time NP lsc scav', REAL(ti_lscs) / REAL(clock_rate)         &
+              , REAL(ti_lscs) / REAL(ti_spla)
+      print *, 'time opt,brdn,etc', REAL(ti_brop) / REAL(clock_rate)        &
+              , REAL(ti_brop) / REAL(ti_spla)
+      print *, 'time outputs', REAL(ti_outs) / REAL(clock_rate)             &
+              , REAL(ti_outs) / REAL(ti_spla)
+
+      print *, '--time accumulated: time proc, time proc/time phytracr_spl--'
+      print *, 'time spla', tia_spla
+      print *, 'time init', tia_init, tia_init / tia_spla
+      print *, 'time inittype', tia_inittype, tia_inittype / tia_spla
+      print *, 'time inittwrite', tia_inittwrite, tia_inittwrite / tia_spla
+      print *, 'time emis', tia_emis, tia_emis / tia_spla
+      print *, 'time depo', tia_depo, tia_depo / tia_spla
+      print *, 'time cltr', tia_cltr, tia_cltr / tia_spla
+      print *, 'time ther', tia_ther, tia_ther / tia_spla
+      print *, 'time sedi', tia_sedi, tia_sedi / tia_spla
+      print *, 'time gas to part', tia_gasp, tia_gasp / tia_spla
+      print *, 'time AP wet', tia_wetap, tia_wetap / tia_spla
+      print *, 'time convective', tia_cvltr, tia_cvltr / tia_spla
+      print *, 'time NP lsc scav', tia_lscs, tia_lscs / tia_spla
+      print *, 'time opt,brdn,etc', tia_brop, tia_brop / tia_spla
+      print *, 'time outputs', tia_outs, tia_outs / tia_spla
+
+      dife = clock_end_outphytracr - clock_start_outphytracr
+      ti_nophytracr = dife * MAX(0, SIGN(1, dife))  &
+              + (dife + clock_per_max) * MAX(0, SIGN(1, -dife))
+      tia_nophytracr = tia_nophytracr + REAL(ti_nophytracr) / REAL(clock_rate)
+      print *, 'Time outside phytracr; Time accum outside phytracr'
+      print*, REAL(ti_nophytracr) / REAL(clock_rate), tia_nophytracr
+
+      clock_start_outphytracr = clock_end
+
+    ENDIF
+    print *, 'END PHYTRACR_SPL '
+    print *, 'lmt_so2ff_l FIN', MINVAL(lmt_so2ff_l), MAXVAL(lmt_so2ff_l)
+
+    !      CALL abort_gcm('TEST1', 'OK1', 1)
+
+    RETURN
+  END SUBROUTINE phytracr_spl
+
+  SUBROUTINE readregionsdims2_spl(nbreg, fileregions)
+
+    USE mod_grid_phy_lmdz
+    USE mod_phys_lmdz_para
+
+    IMPLICIT NONE
+    CHARACTER*800 fileregions
+    CHARACTER*800 auxstr
+    INTEGER nbreg
+
+    IF (is_mpi_root .AND. is_omp_root) THEN
+
+      OPEN (UNIT = 1, FILE = trim(adjustl(fileregions)))
+      READ(1, '(a)') auxstr
+      READ(1, '(i10)') nbreg
+      CLOSE(UNIT = 1)
+    ENDIF
+    CALL bcast(nbreg)
+
+  END SUBROUTINE readregionsdims2_spl
+
+  SUBROUTINE readregionsdims_spl(nbreg_ind, fileregionsdimsind, &
+          nbreg_dust, fileregionsdimsdust, &
+          nbreg_bb, fileregionsdimsbb)
+    USE mod_grid_phy_lmdz
+    USE mod_phys_lmdz_para
+
+    IMPLICIT NONE
+    CHARACTER*800 fileregionsdimsind
+    CHARACTER*800 fileregionsdimsdust
+    CHARACTER*800 fileregionsdimsbb
+    CHARACTER*800 auxstr
+    INTEGER nbreg_ind, nbreg_dust, nbreg_bb
+
+    IF (is_mpi_root .AND. is_omp_root) THEN
+
+      OPEN (UNIT = 1, FILE = trim(adjustl(fileregionsdimsind)))
+      READ(1, '(a)') auxstr
+      READ(1, '(i10)') nbreg_ind
+      CLOSE(UNIT = 1)
+
+      OPEN (UNIT = 1, FILE = trim(adjustl(fileregionsdimsdust)))
+      READ(1, '(a)') auxstr
+      READ(1, '(i10)') nbreg_dust
+      CLOSE(UNIT = 1)
+
+      OPEN (UNIT = 1, FILE = trim(adjustl(fileregionsdimsbb)))
+      READ(1, '(a)') auxstr
+      READ(1, '(i10)') nbreg_bb
+      CLOSE(UNIT = 1)
+
+    ENDIF
+    CALL bcast(nbreg_ind)
+    CALL bcast(nbreg_dust)
+    CALL bcast(nbreg_bb)
+
+  END SUBROUTINE readregionsdims_spl
+
+  SUBROUTINE readregions_spl(iregion, filenameregion)
+    USE dimphy
+    USE mod_grid_phy_lmdz
+    USE mod_phys_lmdz_para
+
+    IMPLICIT NONE
+    CHARACTER*(*) filenameregion
+    INTEGER iregion(klon)
+    INTEGER iregion_glo(klon_glo)
+    INTEGER k
+
+    IF (is_mpi_root .AND. is_omp_root) THEN
+
+      print *, trim(adjustl(filenameregion))
+      OPEN(1, file = trim(adjustl(filenameregion)))
+      DO k = 1, klon_glo
+        READ(1, '(i10)') iregion_glo(k)
+      ENDDO
+      CLOSE(UNIT = 1)
+    ENDIF
+    CALL scatter(iregion_glo, iregion)
+
+  END SUBROUTINE readregions_spl
+
+  !! AS: SUBROUTINE readscaleparams_spl pas appellee
+  SUBROUTINE readscaleparams_spl(scale_param, nbreg, &
+          filescaleparams)
+    USE mod_grid_phy_lmdz
+    USE mod_phys_lmdz_para
+    IMPLICIT NONE
+
+    CHARACTER*800 filescaleparams
+    INTEGER nbreg
+    REAL scale_param(nbreg)
+    INTEGER k
+
+    IF (is_mpi_root .AND. is_omp_root) THEN
+      OPEN(1, file = trim(adjustl(filescaleparams)), form = 'unformatted')
+      do k = 1, nbreg
         read(1)  scale_param(k)
       enddo
-      CLOSE(1)  
-      ENDIF
-      CALL bcast(scale_param)
-!      print *,'holaaaaaaaaaaaa'
-!      print *,scale_param
-
-      END SUBROUTINE readscaleparams_spl
-
-      SUBROUTINE readscaleparamsnc_spl(scale_param_ind,                 &
-        nbreg_ind, paramname_ind,                                       &
-        scale_param_ff, nbreg_ff,paramname_ff,                          &
-        scale_param_bb, nbreg_bb,paramname_bb,                          &
-        scale_param_dustacc, nbreg_dustacc,paramname_dustacc,           &
-        scale_param_dustcoa, nbreg_dustcoa,paramname_dustcoa,           &
-        scale_param_dustsco, nbreg_dustsco,paramname_dustsco,           &
-        param_wstarBLperregion, nbreg_wstardustBL, paramname_wstarBL,     &
-        param_wstarWAKEperregion, nbreg_wstardustWAKE, paramname_wstarWAKE, &
-        scale_param_ssacc  ,  paramname_ssacc,             &
-        scale_param_sscoa  ,  paramname_sscoa,             &
-           filescaleparams,julien,jH_phys, pdtphys,debutphy)
-!      SUBROUTINE readscaleparamsnc_spl(scale_param, nbreg, &
-!                                        filescaleparams,paramname,&
-!                                        julien,jH_phys, pdtphys,debutphy)
-      USE mod_grid_phy_lmdz
-      USE mod_phys_lmdz_para
-      IMPLICIT NONE
-
-      CHARACTER*800 filescaleparams
-      CHARACTER*100 paramname_ind,paramname_ff,paramname_bb          
-      CHARACTER*100 paramname_dustacc, paramname_dustcoa 
-      CHARACTER*100 paramname_dustsco
-      CHARACTER*100 paramname_ssacc
-      CHARACTER*100 paramname_sscoa
-      CHARACTER*100 paramname_wstarBL
-      CHARACTER*100 paramname_wstarWAKE
-     
-      INTEGER nbreg,iday
-      INTEGER nbreg_ind, nbreg_ff, nbreg_bb , nbreg_dustacc
-      INTEGER nbreg_dustcoa , nbreg_dustsco, nbreg_wstardustBL
-      INTEGER  nbreg_wstardustWAKE
-      INTEGER,PARAMETER ::  nbreg_ssacc=1 
-      INTEGER,PARAMETER :: nbreg_sscoa=1 
-      REAL,PARAMETER :: sca_resol = 24. ! resolution of scalig params in hours
-      REAL scale_param_ind(nbreg_ind)
-      REAL scale_param_bb(nbreg_bb)
-      REAL scale_param_ff(nbreg_ff)
-      REAL scale_param_dustacc(nbreg_dustacc)
-      REAL scale_param_dustcoa(nbreg_dustcoa)
-      REAL scale_param_dustsco(nbreg_dustsco)
-      REAL param_wstarBLperregion(nbreg_wstardustBL)
-      REAL param_wstarWAKEperregion(nbreg_wstardustWAKE)
-      REAL scale_param_ssacc
-      REAL scale_param_ssacc_tmp(nbreg_ssacc)
-      REAL scale_param_sscoa
-      REAL scale_param_sscoa_tmp(nbreg_sscoa)
-
-      INTEGER k,step_sca,test_sca
-      REAL :: jH_phys,  pdtphys
-      REAL,SAVE :: jH_sca, jH_ini
-      INTEGER julien
-      LOGICAL debutphy
-      SAVE step_sca,test_sca,iday
-!$OMP THREADPRIVATE(step_sca,test_sca,iday)
-!$OMP THREADPRIVATE(jH_sca,jH_ini)
-
-      IF (debutphy) THEN
-        iday=julien
-        step_sca=1
-        test_sca=0   
-        jH_ini=jH_phys
-        jH_sca=jH_phys
-      ENDIF
-
-      IF (test_sca == 0 ) THEN
-        ! READ file!!
-        call read_scalenc(filescaleparams,paramname_ind,            &
-                           nbreg_ind,step_sca,                      &
-                           scale_param_ind)
-        call read_scalenc(filescaleparams,paramname_bb,            &
-                           nbreg_bb,step_sca,                      &
-                           scale_param_bb)
-        call read_scalenc(filescaleparams,paramname_ff,            &
-                           nbreg_ff,step_sca,                      &
-                           scale_param_ff)
-        call read_scalenc(filescaleparams,paramname_dustacc,            &
-                           nbreg_dustacc,step_sca,                      &
-                           scale_param_dustacc)
-        call read_scalenc(filescaleparams,paramname_dustcoa,            &
-                           nbreg_dustcoa,step_sca,                      &
-                           scale_param_dustcoa)
-        call read_scalenc(filescaleparams,paramname_dustsco,            &
-                           nbreg_dustsco,step_sca,                      &
-                           scale_param_dustsco)
-        call read_scalenc(filescaleparams,paramname_wstarBL,            &
-                           nbreg_wstardustBL,step_sca,                    &
-                           param_wstarBLperregion)
-        call read_scalenc(filescaleparams,paramname_wstarWAKE,          &
-                           nbreg_wstardustWAKE,step_sca,                    &
-                           param_wstarWAKEperregion)
-        call read_scalenc(filescaleparams,paramname_ssacc,              &
-                           nbreg_ssacc,step_sca,                        &
-                           scale_param_ssacc_tmp)
-        call read_scalenc(filescaleparams,paramname_sscoa,              &
-                           nbreg_sscoa,step_sca,                        &
-                           scale_param_sscoa_tmp)
-         scale_param_ssacc=scale_param_ssacc_tmp(1)
-         scale_param_sscoa=scale_param_sscoa_tmp(1)
-
-       !print *,'JEREADFILE',julien,jH_phys
-        step_sca= step_sca + 1
-        test_sca=1
-      ENDIF
-
-      jH_sca=jH_sca+pdtphys/(24.*3600.)
-      IF (jH_sca>(sca_resol)/24.) THEN
-          test_sca=0
-          jH_sca=jH_ini
-      ENDIF
-
-      END SUBROUTINE readscaleparamsnc_spl
-
-      SUBROUTINE read_scalenc(filescaleparams,paramname,nbreg,step_sca, &
-                          scale_param)
-
-      USE mod_grid_phy_lmdz
-      USE mod_phys_lmdz_para
-      USE netcdf, ONLY:nf90_open,nf90_close,nf90_inq_varid,nf90_nowrite,nf90_noerr,nf90_get_var
-      IMPLICIT NONE
-
-      CHARACTER*800 filescaleparams
-      CHARACTER*100 paramname
-      INTEGER nbreg, step_sca
-      REAL scale_param(nbreg)
-      !local vars
-      integer nid,ierr,nvarid
-      real rcode,auxreal
-      integer start(4),count(4), status
-!      local
-      integer debutread,countread
-      CHARACTER*104 varname
-      CHARACTER*2 aux_2s
-      integer i, j, ig
-!$OMP MASTER
-      IF (is_mpi_root .AND. is_omp_root) THEN
-          !nci=NCOPN(trim(adjustl(filescaleparams)),NCNOWRIT,rcode)
-         ierr = nf90_open (trim(adjustl(filescaleparams)),nf90_nowrite, nid)
-          if (ierr == nf90_noerr) THEN
-          debutread=step_sca
-          countread=1
-
-           do i=1,nbreg
-            WRITE(aux_2s,'(i2.2)') i
-            varname= trim(adjustl(paramname))//aux_2s
-            print *,varname
-            ierr = nf90_inq_varid (nid,trim(adjustl(varname)), nvarid)
-            ierr = nf90_get_var (nid, nvarid, auxreal, debutread, countread)
-            IF (ierr /= nf90_noerr) THEN
-             PRINT*, 'Pb de lecture pour modvalues'
-       print *,'JE  scale_var, step_sca',trim(adjustl(varname)),step_sca
-             CALL HANDLE_ERR(ierr)
-             print *,'error ierr= ',ierr
-             CALL exit(1) 
-            call abort_gcm('read_scalenc','error reading variable',1)
-      ENDIF
-
-            print *,auxreal
-            scale_param(i)=auxreal 
-           enddo
-
-            ierr = nf90_close(nid)
-          else
-           print *,'File '//trim(adjustl(filescaleparams))//' not found'
-            print *,'doing nothing...'
-          endif
-
-      ENDIF ! mpi_root
-!$OMP END MASTER
-!$OMP BARRIER
-!      CALL scatter(var local _glo,var local) o algo asi
-      call bcast(scale_param)
-      END SUBROUTINE read_scalenc
-
-
-      
-      END MODULE
+      CLOSE(1)
+    ENDIF
+    CALL bcast(scale_param)
+    !      print *,'holaaaaaaaaaaaa'
+    !      print *,scale_param
+
+  END SUBROUTINE readscaleparams_spl
+
+  SUBROUTINE readscaleparamsnc_spl(scale_param_ind, &
+          nbreg_ind, paramname_ind, &
+          scale_param_ff, nbreg_ff, paramname_ff, &
+          scale_param_bb, nbreg_bb, paramname_bb, &
+          scale_param_dustacc, nbreg_dustacc, paramname_dustacc, &
+          scale_param_dustcoa, nbreg_dustcoa, paramname_dustcoa, &
+          scale_param_dustsco, nbreg_dustsco, paramname_dustsco, &
+          param_wstarBLperregion, nbreg_wstardustBL, paramname_wstarBL, &
+          param_wstarWAKEperregion, nbreg_wstardustWAKE, paramname_wstarWAKE, &
+          scale_param_ssacc, paramname_ssacc, &
+          scale_param_sscoa, paramname_sscoa, &
+          filescaleparams, julien, jH_phys, pdtphys, debutphy)
+    !      SUBROUTINE readscaleparamsnc_spl(scale_param, nbreg, &
+    !                                        filescaleparams,paramname,&
+    !                                        julien,jH_phys, pdtphys,debutphy)
+    USE mod_grid_phy_lmdz
+    USE mod_phys_lmdz_para
+    IMPLICIT NONE
+
+    CHARACTER*800 filescaleparams
+    CHARACTER*100 paramname_ind, paramname_ff, paramname_bb
+    CHARACTER*100 paramname_dustacc, paramname_dustcoa
+    CHARACTER*100 paramname_dustsco
+    CHARACTER*100 paramname_ssacc
+    CHARACTER*100 paramname_sscoa
+    CHARACTER*100 paramname_wstarBL
+    CHARACTER*100 paramname_wstarWAKE
+
+    INTEGER nbreg, iday
+    INTEGER nbreg_ind, nbreg_ff, nbreg_bb, nbreg_dustacc
+    INTEGER nbreg_dustcoa, nbreg_dustsco, nbreg_wstardustBL
+    INTEGER  nbreg_wstardustWAKE
+    INTEGER, PARAMETER :: nbreg_ssacc = 1
+    INTEGER, PARAMETER :: nbreg_sscoa = 1
+    REAL, PARAMETER :: sca_resol = 24. ! resolution of scalig params in hours
+    REAL scale_param_ind(nbreg_ind)
+    REAL scale_param_bb(nbreg_bb)
+    REAL scale_param_ff(nbreg_ff)
+    REAL scale_param_dustacc(nbreg_dustacc)
+    REAL scale_param_dustcoa(nbreg_dustcoa)
+    REAL scale_param_dustsco(nbreg_dustsco)
+    REAL param_wstarBLperregion(nbreg_wstardustBL)
+    REAL param_wstarWAKEperregion(nbreg_wstardustWAKE)
+    REAL scale_param_ssacc
+    REAL scale_param_ssacc_tmp(nbreg_ssacc)
+    REAL scale_param_sscoa
+    REAL scale_param_sscoa_tmp(nbreg_sscoa)
+
+    INTEGER k, step_sca, test_sca
+    REAL :: jH_phys, pdtphys
+    REAL, SAVE :: jH_sca, jH_ini
+    INTEGER julien
+    LOGICAL debutphy
+    SAVE step_sca, test_sca, iday
+    !$OMP THREADPRIVATE(step_sca,test_sca,iday)
+    !$OMP THREADPRIVATE(jH_sca,jH_ini)
+
+    IF (debutphy) THEN
+      iday = julien
+      step_sca = 1
+      test_sca = 0
+      jH_ini = jH_phys
+      jH_sca = jH_phys
+    ENDIF
+
+    IF (test_sca == 0) THEN
+      ! READ file!!
+      call read_scalenc(filescaleparams, paramname_ind, &
+              nbreg_ind, step_sca, &
+              scale_param_ind)
+      call read_scalenc(filescaleparams, paramname_bb, &
+              nbreg_bb, step_sca, &
+              scale_param_bb)
+      call read_scalenc(filescaleparams, paramname_ff, &
+              nbreg_ff, step_sca, &
+              scale_param_ff)
+      call read_scalenc(filescaleparams, paramname_dustacc, &
+              nbreg_dustacc, step_sca, &
+              scale_param_dustacc)
+      call read_scalenc(filescaleparams, paramname_dustcoa, &
+              nbreg_dustcoa, step_sca, &
+              scale_param_dustcoa)
+      call read_scalenc(filescaleparams, paramname_dustsco, &
+              nbreg_dustsco, step_sca, &
+              scale_param_dustsco)
+      call read_scalenc(filescaleparams, paramname_wstarBL, &
+              nbreg_wstardustBL, step_sca, &
+              param_wstarBLperregion)
+      call read_scalenc(filescaleparams, paramname_wstarWAKE, &
+              nbreg_wstardustWAKE, step_sca, &
+              param_wstarWAKEperregion)
+      call read_scalenc(filescaleparams, paramname_ssacc, &
+              nbreg_ssacc, step_sca, &
+              scale_param_ssacc_tmp)
+      call read_scalenc(filescaleparams, paramname_sscoa, &
+              nbreg_sscoa, step_sca, &
+              scale_param_sscoa_tmp)
+      scale_param_ssacc = scale_param_ssacc_tmp(1)
+      scale_param_sscoa = scale_param_sscoa_tmp(1)
+
+      !print *,'JEREADFILE',julien,jH_phys
+      step_sca = step_sca + 1
+      test_sca = 1
+    ENDIF
+
+    jH_sca = jH_sca + pdtphys / (24. * 3600.)
+    IF (jH_sca>(sca_resol) / 24.) THEN
+      test_sca = 0
+      jH_sca = jH_ini
+    ENDIF
+
+  END SUBROUTINE readscaleparamsnc_spl
+
+  SUBROUTINE read_scalenc(filescaleparams, paramname, nbreg, step_sca, &
+          scale_param)
+
+    USE mod_grid_phy_lmdz
+    USE mod_phys_lmdz_para
+    USE netcdf, ONLY : nf90_open, nf90_close, nf90_inq_varid, nf90_nowrite, nf90_noerr, nf90_get_var
+    IMPLICIT NONE
+
+    CHARACTER*800 filescaleparams
+    CHARACTER*100 paramname
+    INTEGER nbreg, step_sca
+    REAL scale_param(nbreg)
+    !local vars
+    integer nid, ierr, nvarid
+    real rcode, auxreal
+    integer start(4), count(4), status
+    !      local
+    CHARACTER*104 varname
+    CHARACTER*2 aux_2s
+    integer i, j, ig
+    !$OMP MASTER
+    IF (is_mpi_root .AND. is_omp_root) THEN
+      ierr = nf90_open(trim(adjustl(filescaleparams)), nf90_nowrite, nid)
+      if (ierr == nf90_noerr) THEN
+        do i = 1, nbreg
+          WRITE(aux_2s, '(i2.2)') i
+          varname = trim(adjustl(paramname)) // aux_2s
+          print *, varname
+          ierr = nf90_inq_varid(nid, trim(adjustl(varname)), nvarid)
+          ierr = nf90_get_var(nid, nvarid, auxreal, [step_sca])
+          IF (ierr /= nf90_noerr) THEN
+            PRINT*, 'Pb de lecture pour modvalues'
+            print *, 'JE  scale_var, step_sca', trim(adjustl(varname)), step_sca
+            CALL HANDLE_ERR(ierr)
+            print *, 'error ierr= ', ierr
+            CALL exit(1)
+            call abort_gcm('read_scalenc', 'error reading variable', 1)
+          ENDIF
+
+          print *, auxreal
+          scale_param(i) = auxreal
+        enddo
+
+        ierr = nf90_close(nid)
+      else
+        print *, 'File ' // trim(adjustl(filescaleparams)) // ' not found'
+        print *, 'doing nothing...'
+      endif
+
+    ENDIF ! mpi_root
+    !$OMP END MASTER
+    !$OMP BARRIER
+    !      CALL scatter(var local _glo,var local) o algo asi
+    call bcast(scale_param)
+  END SUBROUTINE read_scalenc
+
+
+END MODULE
